#define atari 1
#define pc    2
#define rechner pc
#define popad_bug 1

/*
Version 
0.24  29.3.93
0.25   4.8.93   dsr Fehler behoben
0.26  10.2.94   Labels die mit Punkt beginnen
0.27 14.11.00   ext.w ext.l opcode 98 (war 90)
0.28 29.12.01   rts.ww opcode ca (war c2)

0.30  1.10.02   keine Unterstuetzung mehr fuer ATARI
                seg32=0 in pass2
                unlk.x r4 (war ohne r4)
                Fileposition in listing ausgeben (@@)
                even n,m (even4, even16 weiterhin moeglich)
                evencom n,m
                dc.bw
                read_char(): falls instring wegen (): A-Z -> a-z
                             Fuehrte zu Fehler bei jmp (label) 
                             falls label Grobuchst. enthaelt

0.31 16.08.03   rep_r2 in/out (war repeq_r2)
                (r.x*8) korrigiert
                rep_r2 innerhalb IF 0 gabe Fehler

0.32 15.05.06   Returncode fuer byte/word Zahlen (~high8 -> min8)
                kein seg prefix bei lea
                nicht nur move.w sondern auch move.l si,rk
                ldsl src<->dest

0.33 07.08.06   doppeltes fclose entfernt (Absturz in Linux)

0.34 06.12.06   jmp.ww jmp.wl bsr.ww jsr.wl seg32 -> op32
0.35 14.12.06   dc.w_ dc.l_ CPUID RDTSC
0.36 05.02.07   Fehler in find_lab (Endlosschleife falls _-Label
                nach @-Label 
0.37 23.05.07   prefetch.b n,MADR
     02.08.07   la[--j]=la[j]*la[j+1]; -> j--; la[j]=la[j]*la[j+1];

0.38 03.08.07   rol.b war rocl.b
0.39 21.03.08   opcode halt f4 (war 99)

-------------------------------------------------------------------
                                
fuer ATARI ST 
uebersetzt mit Entwicklungspacket von ATARI (1985)

fuer PC (MS-DOS)
ubersetzt mit GNU CC

 "Das Programm wurde weder hinsichtlich Geschwindigkeit, Groesse oder 
 Leistungsumfang sonder allein hinsichtlich einer kurzen Programmier-
 zeit optimiert."

Programmfehler bitte melden:

klee@unibwm.de

*/



/**********************************************************************

 Folgende externe Datenstrukturen bzw. Funktionen werden benoetigt;

 FILE
 stdin
 stdout
 fopen()    : Textdatei
 fopenb()   : Binaerdatei: keine Umwandlung  cr lf  <->  lf
 fclose()
 getc()
 putc()
 exit()

 int kann 2 oder 4 Byte gross sein
 long muss 4 Byte gross sein

 Durch die ausschliessliche Verwendung obiger Funktionen ist das
 Programm zwar leicht auf andere Rechner zu uebertragen, es ist 
 dafuer aber sehr langsam.
 

**********************************************************************/

#define abs(x) (((x) >= 0) ? (x) : (- (x))) 

#include <stdio.h>

#define maxlabel 5000
#define maxbuf 40000
#define max_line_lang 160
#define max_if 10

#define max8     127L
#define min8    -128L
#define max16  32767L
#define min16 -32768L
#define high8    255L
#define low8       0L
#define high16 65535L
#define low16      0L


#define TAB  9
#define EOL 10
#define CR  13
/*define NULL 0*/
#define BS   8

#if rechner==atari
#define EOF -1
#endif




typedef struct {int nr,reg1,reg2; long konst; int segm;} op_typ;

FILE *mac, *lst, *com, *fopen(), *fopenb();

char lab_buf[maxbuf + max_line_lang+5]; /* Labelnamen              */
char *lab_pa[maxlabel+5];               /* Pointer auf Labelnamen  */
long lab_wert[maxlabel+5];              /* Werte der Labels        */
char lab_guelt[maxlabel+5];             /* 0    : Blockmarkierung  */
                                        /* 1/-1 : lokales Label    */
                                        /* 2/-2 : normales Label   */
                                        /* 3/-3 : globales Label   */
                                        /* 4    : @-Label          */
                                        /* negativ: Wert ungueltig */
int lab_block=2;              /* Nummer des letzen Blockbeginns    */
int lab_lokal=2;              /* Nummer des ersten lokalen  Labels */
int lab_last= -1;             /* Nummer des letzen eingetr. Labels */


char last_line[160];
int  l_line_lang=0;

int  if_wert=0;
int  list_level=0;

int  last_ch=0;
int  next_ch;
int  line_nr=1;
int  line_sp=0;
int  op_pref;
int  pass2=0;
int  blk_flag=0;

int  seg32=0;

/*************************************************************/

main()
{
 long li,lj,lk;
 int i,j;
 int op32;
 char *p,*q;

 char if_stack[max_if+5];
 int  if_level=0;

 char opcode[max_line_lang];
 char operand[max_line_lang];

 op_typ  op1,op2,op3;

 char file_name[20];

 print_string("\n  *****************************************************");
 print_string("\n  *                                                   *");
 print_string("\n  *   DDDD    AAA   N   N  III  EEEEE  L       AAA    *");
 print_string("\n  *   D   D  A   A  NN  N   I   E      L      A   A   *");
 print_string("\n  *   D   D  AAAAA  N N N   I   EEEE   L      AAAAA   *");
 print_string("\n  *   D   D  A   A  N  NN   I   E      L      A   A   *");
 print_string("\n  *   DDDD   A   A  N   N  III  EEEEE  LLLLL  A   A   *");
 print_string("\n  *                                                   *");
 print_string("\n  *   Der                                             *");
 print_string("\n  *   ANdere                                          *");
 print_string("\n  *   IntEL 486                   Version 0.39        *");
 print_string("\n  *   Assembler                     21.03.08          *");
 print_string("\n  *                                                   *");
 print_string("\n  *                                                   *");
 print_string("\n  *****************************************************");
 print_string("\n\n");
#if rechner==atari
 print_string("\n  Eingabe nicht mit RETURN sondern mit EOL (^J) beenden");
#endif
 print_string("\n\n  Filename (ohne .mac): ");

 i=0;
 p=file_name;
 while (1)
    {*p = getc(stdin);
     if (*p == EOL || *p == CR) break;

#if rechner==atari
     if (*p == BS) {if (i) {/* putc(*p,stdout); nicht bei lokal echo*/
                            putc(' ',stdout);
                            putc(*p,stdout);
                            i--; p--;
                           }
                           else putc(' ',stdout); /*bei lokal echo*/
                    continue;
                   }
     putc(BS,stdout); putc(' ',stdout); putc(BS,stdout); /*bei lokal echo*/
     if (i<8) {putc(*p++,stdout); i++;}
#endif

#if rechner==pc
     if (i<8) p++,i++;
#endif

    }
 *p++ = '.';  *p++ = 'm';  *p++ = 'a';  *p++ = 'c';  *p = 0; 

 mac = fopen(file_name,"r");
 if (mac==NULL) ende(1,31);
 next_ch = getc(mac);


 lab_pa[0]=lab_buf;
 lab_guelt[0]=0;
 ins_lab("@",0L,4);
 ins_lab("@@",0L,4);
 print_string("\n Pass 1\n");

 do
   {
    if (pass2) 
     { /*ini pass 2*/
       fclose(mac);
       last_ch=0;
       mac = fopen(file_name,"r");
       if (mac==NULL) ende(2,31);
       next_ch = getc(mac);
       p=file_name; while (*p++ != '.'); *p++ = 'l'; *p++ = 's'; *p = 't'; 
       lst = fopen(file_name,"w");
       if (lst==NULL) ende(3,32);
       p=file_name; while (*p++ != '.'); *p++ = 'c'; *p++ = 'o'; *p = 'm'; 

#if rechner==atari
       com = fopenb(file_name,"w");
#endif

#if rechner==pc
       com = fopen(file_name,"wb");
#endif

       if (com==NULL) ende(4,33);
       seg32=0;
       line_nr=1;
       line_sp=0;
       blk_flag=0;
       lab_wert[0]=0;
       lab_wert[1]=0;
       lab_block=2;
       lab_lokal=2;
       if_level=0;
       if_wert=0;
       list_level=0;
       print_string(" Pass 2\n");
     }

    while (get_opcode(opcode))
     {if (cmps(opcode,"if")) goto _if;
      if (cmps(opcode,"else")) goto _else;
      if (cmps(opcode,"endif")) goto _endif;
      if (if_wert < 0) {skip_line(); goto nextline;}

      op32=0;
      switch(opcode[0]) 
       {case  0 : break;
        case '=': {j=2; goto op__;};
        case ':': {j=3; goto op__;};
        case 'a': goto op_a;
        case 'b': goto op_b;
        case 'c': goto op_c;
        case 'd': goto op_d;
        case 'e': goto op_e;
        case 'f': goto op_f;
        case 'g': goto op_g;
        case 'h': goto op_h;
        case 'i': goto op_i;
        case 'j': goto op_j;
        case 'k': goto op_k;
        case 'l': goto op_l;
        case 'm': goto op_m;
        case 'n': goto op_n;
        case 'o': goto op_o;
        case 'p': goto op_p;
        case 'q': goto op_q;
        case 'r': goto op_r;
        case 's': goto op_s;
        case 't': goto op_t;
        case 'u': goto op_u;
        case 'v': goto op_v;
        case 'w': goto op_w;
        case 'x': goto op_x;
        case 'y': goto op_y;
        case 'z': goto op_z;
        default:  ende(5,1);
       }

#if rechner==atari
      nextl1: 
#endif
#if rechner==pc
      nextline: 
#endif

      if (op_pref&&if_wert>=0) ende(6,2); 
      read_eol();
     }
    if (if_wert) ende(7,27); 
    pass2=!pass2;
   } while (pass2);

 list_label();
 ende(0,0);


/*************************************************************/
/*************************************************************/
_if:
 get_operand(operand);
 if (if_level > max_if) ende(8,28);
 if_stack[if_level++] = if_wert;
 if (if_wert<0) {if_wert = -2; goto nextline;}
 if (! get_w(operand,&li)) ende(9,10);
 if (li) if_wert = 1; else if_wert = -1;
 goto nextline;

_else:
 if (if_wert ==  1 || if_wert ==  -2) {if_wert = -3; goto nextline;}
 if (if_wert == -1)                   {if_wert =  2; goto nextline;}
 ende(10,29);

_endif:
 if (!if_level) ende (11,30);
 if_wert = if_stack[--if_level];
 goto nextline;
  

/*************************************************************/
/*************************************************************/
_addb:
 get_operand(operand);
 dec_boperand(operand,&op1); 
 get_operand(operand);
 dec_boperand(operand,&op2); 

 if (op1.nr == 34  && op2.nr == 3 && op2.reg1 == 0)
   {if (op1.reg1 != 1) ende(12,4);
    aus_byte(0x04);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (op1.reg1 != 1) ende(13,4);
    if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0x80);
    mod__sib(0,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op2.nr >= 3 && op2.nr <= 30 )
   {if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0x00);
    mod_sib(op1.reg1,&op2);
    goto nextline;
   }

 if ( op2.nr == 3 && op1.nr >= 3  && op1.nr <= 30)
   {
    adr_pre(&op1);
    seg_pre(&op1);
    aus_byte(0x02);
    mod_sib(op2.reg1,&op1);
    goto nextline;
   }

 ende(14,3);

/*************************************************************/
_addl:
 op32=1;
/*-----------------------------------------------------------*/
_addw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr == 34  && op2.nr == 3 && op2.reg1 == 0)
   {if (!op32 && op1.reg1 > 2) ende(15,5);
    if (seg32 ^ op32) aus_byte(0x66);
    aus_byte(0x05);
    if (! op32) aus_word((int)op1.konst); else aus_long(op1.konst);
    goto nextline;
   }

 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (!op32 && op1.reg1 > 2) ende(16,5);
    if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x81);
    mod__sib(0,&op2);
    if (! op32) aus_word((int)op1.konst); else aus_long(op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op2.nr >= 3 && op2.nr <= 30 )
   {if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x01);
    mod_sib(op1.reg1,&op2);
    goto nextline;
   }

 if ( op2.nr == 3 && op1.nr >= 3  && op1.nr <= 30)
   {
    adr_pre(&op1);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op1);
    aus_byte(0x03);
    mod_sib(op2.reg1,&op1);
    goto nextline;
   }

ende(17,3);

/*************************************************************/
_addcb:
 get_operand(operand);
 dec_boperand(operand,&op1); 
 get_operand(operand);
 dec_boperand(operand,&op2); 

 if (op1.nr == 34  && op2.nr == 3 && op2.reg1 == 0)
   {if (op1.reg1 != 1) ende(18,4);
    aus_byte(0x14);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (op1.reg1 != 1) ende(19,4);
    if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0x80);
    mod__sib(2,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op2.nr >= 3 && op2.nr <= 30 )
   {if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0x10);
    mod_sib(op1.reg1,&op2);
    goto nextline;
   }

 if ( op2.nr == 3 && op1.nr >= 3  && op1.nr <= 30)
   {
    adr_pre(&op1);
    seg_pre(&op1);
    aus_byte(0x12);
    mod_sib(op2.reg1,&op1);
    goto nextline;
   }

ende(20,3);


/*************************************************************/
_addcl:
 op32=1;
/*-----------------------------------------------------------*/

_addcw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr == 34  && op2.nr == 3 && op2.reg1 == 0)
   {if (!op32 && op1.reg1 > 2) ende(21,5);
    if (seg32 ^ op32) aus_byte(0x66);
    aus_byte(0x15);
    if (! op32) aus_word((int)op1.konst); else aus_long(op1.konst);
    goto nextline;
   }

 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (!op32 && op1.reg1 > 2) ende(22,5);
    if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x81);
    mod__sib(2,&op2);
    if (! op32) aus_word((int)op1.konst); else aus_long(op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op2.nr >= 3 && op2.nr <= 30 )
   {if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x11);
    mod_sib(op1.reg1,&op2);
    goto nextline;
   }

 if ( op2.nr == 3 && op1.nr >= 3  && op1.nr <= 30)
   {
    adr_pre(&op1);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op1);
    aus_byte(0x13);
    mod_sib(op2.reg1,&op1);
    goto nextline;
   }

 ende(23,3);

/*************************************************************/
_addcql:
 op32=1;
/*-----------------------------------------------------------*/
_addcqw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (op1.reg1 != 1) ende(24,4);
    if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x83);
    mod__sib(2,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 ende(25,3);

/*************************************************************/
_addql:
 op32=1;
/*-----------------------------------------------------------*/
_addqw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (op1.reg1 != 1) ende(26,4);
    if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x83);
    mod__sib(0,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 ende(27,3);

/*************************************************************/
_aaadd:
 get_operand(operand);
 dec_operand(operand,&op1); 

 if (op1.nr == 3  && op1.reg1 == 0)
   {aus_byte(0x37);
    goto nextline;
   }

 ende(28,3);

/*************************************************************/
_aadiv:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr == 3  && op1.reg1 == 0 && op2.nr == 1)
   {aus_byte(0xd5);
    aus_byte(0x0a);
    goto nextline;
   }

 if (op1.nr == 34  && op2.nr == 3 && op2.reg1 == 0 )
   {if (op1.reg1 != 1) ende(29,4);
    aus_byte(0xd5);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 ende(29,3);

/*************************************************************/
_aamul:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr == 3  && op1.reg1 == 0 && op2.nr == 1)
   {aus_byte(0xd4);
    aus_byte(0x0a);
    goto nextline;
   }

 if (op1.nr == 34  && op2.nr == 3 && op2.reg1 == 0 )
   {if (op1.reg1 != 1) ende(30,4);
    aus_byte(0xd4);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 ende(30,3);

/*************************************************************/
_aaasub:
 get_operand(operand);
 dec_operand(operand,&op1); 

 if (op1.nr == 3  && op1.reg1 == 0)
   {aus_byte(0x3f);
    goto nextline;
   }

 ende(31,3);

/*************************************************************/
_adadd:
 get_operand(operand);
 dec_operand(operand,&op1); 

 if (op1.nr == 3  && op1.reg1 == 0)
   {aus_byte(0x27);
    goto nextline;
   }

 ende(32,3);

/*************************************************************/
_adsub:
 get_operand(operand);
 dec_operand(operand,&op1); 

 if (op1.nr == 3  && op1.reg1 == 0)
   {aus_byte(0x2f);
    goto nextline;
   }

 ende(33,3);

/*************************************************************/
_andb:
 get_operand(operand);
 dec_boperand(operand,&op1); 
 get_operand(operand);
 dec_boperand(operand,&op2); 

 if (op1.nr == 34  && op2.nr == 3 && op2.reg1 == 0)
   {if (op1.reg1 != 1) ende(34,4);
    aus_byte(0x24);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (op1.reg1 != 1) ende(35,4);
    if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0x80);
    mod__sib(4,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op2.nr >= 3 && op2.nr <= 30 )
   {if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0x20);
    mod_sib(op1.reg1,&op2);
    goto nextline;
   }

 if ( op2.nr == 3 && op1.nr >= 3  && op1.nr <= 30)
   {
    adr_pre(&op1);
    seg_pre(&op1);
    aus_byte(0x22);
    mod_sib(op2.reg1,&op1);
    goto nextline;
   }

 ende(36,3);

/*************************************************************/
_andl:
 op32=1;
/*-----------------------------------------------------------*/
_andw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr == 34  && op2.nr == 3 && op2.reg1 == 0)
   {if (!op32 && op1.reg1 > 2) ende(37,5);
    if (seg32 ^ op32) aus_byte(0x66);
    aus_byte(0x25);
    if (! op32) aus_word((int)op1.konst); else aus_long(op1.konst);
    goto nextline;
   }

 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (!op32 && op1.reg1 > 2) ende(38,5);
    if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x81);
    mod__sib(4,&op2);
    if (! op32) aus_word((int)op1.konst); else aus_long(op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op2.nr >= 3 && op2.nr <= 30 )
   {if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x21);
    mod_sib(op1.reg1,&op2);
    goto nextline;
   }

 if ( op2.nr == 3 && op1.nr >= 3  && op1.nr <= 30)
   {
    adr_pre(&op1);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op1);
    aus_byte(0x23);
    mod_sib(op2.reg1,&op1);
    goto nextline;
   }

 ende(39,3);

/*************************************************************/
_andql:
 op32=1;
/*-----------------------------------------------------------*/
_andqw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (op1.reg1 != 1) ende(40,4);
    if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x83);
    mod__sib(4,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 ende(41,3);

/*************************************************************/
_arplw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if ( op1.nr == 3 && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0x63);
    mod_sib(op1.reg1,&op2);
    goto nextline;
   }

 ende(42,3);

/*************************************************************/
_aslb:
 get_operand(operand);
 dec_operand(operand,&op1); 
 if (cmps(operand,"#1")) i=1; else i=0;
 get_operand(operand);
 dec_boperand(operand,&op2); 

 if ( i && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0xd0);
    mod__sib(4,&op2);
    goto nextline;
   }
 
 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (op1.reg1 != 1) ende(43,4);
    adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0xc0);
    mod__sib(4,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op1.reg1==2 && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0xd2);
    mod__sib(4,&op2);
    goto nextline;
   }

 ende(44,3);

/*************************************************************/
_asll:
 op32=1;
/*-----------------------------------------------------------*/
_aslw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 if (cmps(operand,"#1")) i=1; else i=0;
 get_operand(operand);
 dec_operand(operand,&op2); 

 if ( i && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0xd1);
    mod__sib(4,&op2);
    goto nextline;
   }
 
 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (op1.reg1 != 1) ende(45,4);
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0xc1);
    mod__sib(4,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op1.reg1==2 && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0xd3);
    mod__sib(4,&op2);
    goto nextline;
   }

 ende(46,3);

/*************************************************************/
_asrb:
 get_operand(operand);
 dec_operand(operand,&op1); 
 if (cmps(operand,"#1")) i=1; else i=0;
 get_operand(operand);
 dec_boperand(operand,&op2); 

 if ( i && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0xd0);
    mod__sib(7,&op2);
    goto nextline;
   }
 
 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (op1.reg1 != 1) ende(47,4);
    adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0xc0);
    mod__sib(7,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op1.reg1==2 && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0xd2);
    mod__sib(7,&op2);
    goto nextline;
   }

 ende(48,3);

/*************************************************************/
_asrl:
 op32=1;
/*-----------------------------------------------------------*/
_asrw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 if (cmps(operand,"#1")) i=1; else i=0;
 get_operand(operand);
 dec_operand(operand,&op2); 

 if ( i && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0xd1);
    mod__sib(7,&op2);
    goto nextline;
   }
 
 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (op1.reg1 != 1) ende(49,4);
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0xc1);
    mod__sib(7,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op1.reg1==2 && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0xd3);
    mod__sib(7,&op2);
    goto nextline;
   }

 ende(50,3);

/*************************************************************/

/*===========================================================*/
_bb:
 get_operand(operand);
 get_wert(operand,&li);
 if      (op_pref==5) {op_pref=0; if (seg32) aus_byte(0x66);}
 else if (op_pref==6) {op_pref=0; if (! seg32) aus_byte(0x66);}
 aus_byte(i);
 li -= *lab_wert+1;
 if (pass2 && (li > max8 || li < min8)) ende(51,6);
 aus_byte((int)li);
 goto nextline;

_bl:
 get_operand(operand);
 get_wert(operand,&li);
 if (!seg32) aus_byte(0x66);
 aus_byte(0x0f);
 aus_byte(i);
 li -= *lab_wert+4;
 aus_long(li);
 goto nextline;

_bw:
 get_operand(operand);
 get_wert(operand,&li);
 if (seg32) aus_byte(0x66);
 aus_byte(0x0f);
 aus_byte(i);
 li -= *lab_wert + 2;
 if (pass2 && (li > max16 || li < min16) )
    ende(52,6);
 aus_word((int)li); 
 goto nextline;

/*===========================================================*/


/*************************************************************/
_bccb:
 i=0x73;
 goto _bb;

_bccl:
 i=0x83;
 goto _bl;

_bccw:
 i=0x83;
 goto _bw;

/*************************************************************/
_bcsb:
 i=0x72;
 goto _bb;

_bcsl:
 i=0x82;
 goto _bl;

_bcsw:
 i=0x82;
 goto _bw;

/*************************************************************/
_bchgl:
 op32=1;
/*-----------------------------------------------------------*/
_bchgw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (op1.reg1 != 1) ende(53,4);
    if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x0f);
    aus_byte(0xba);
    mod__sib(7,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op2.nr >= 3 && op2.nr <= 30 )
   {if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x0f);
    aus_byte(0xbb);
    mod_sib(op1.reg1,&op2);
    goto nextline;
   }

 if (op1.nr == 34  && op2.nr == 35)
   {if (op1.konst) ende(54,3);
    aus_byte(0xf5);
    goto nextline;
   }

 ende(55,3);

/*************************************************************/
_bclrl:
 op32=1;
/*-----------------------------------------------------------*/
_bclrw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (!op32 && op1.reg1 > 2) ende(56,5);
    if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x0f);
    aus_byte(0xba);
    mod__sib(6,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op2.nr >= 3 && op2.nr <= 30 )
   {if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x0f);
    aus_byte(0xb3);
    mod_sib(op1.reg1,&op2);
    goto nextline;
   }

 if (op1.nr == 34  && op2.nr == 35)
   {if      (op1.konst == (long)  0 )  aus_byte(0xf8);
    else if (op1.konst == (long)  3 ) {aus_byte(0x0f);aus_byte(0x06);}
    else if (op1.konst == (long)  9 )  aus_byte(0xfa);
    else if (op1.konst == (long) 10 )  aus_byte(0xfc);
    else ende(57,3);
    goto nextline;
   }

 ende(58,3);

/*************************************************************/
_beqb:
 i=0x74;
 goto _bb;

_beql:
 i=0x84;
 goto _bl;

_beqw:
 i=0x84;
 goto _bw;

/*************************************************************/
_beqr2lb:
 if (!seg32) aus_byte(0x66);
 i=0xe3;
 goto _bb;

_beqr2wb:
 if (seg32) aus_byte(0x66);
 i=0xe3;
 goto _bb;

/*************************************************************/
_bgeb:
 i=0x7d;
 goto _bb;

_bgel:
 i=0x8d;
 goto _bl;

_bgew:
 i=0x8d;
 goto _bw;

/*************************************************************/
_bgtb:
 i=0x7f;
 goto _bb;

_bgtl:
 i=0x8f;
 goto _bl;

_bgtw:
 i=0x8f;
 goto _bw;

/*************************************************************/
_bhib:
 i=0x77;
 goto _bb;

_bhil:
 i=0x87;
 goto _bl;

_bhiw:
 i=0x87;
 goto _bw;

/*************************************************************/
_bleb:
 i=0x7e;
 goto _bb;

_blel:
 i=0x8e;
 goto _bl;

_blew:
 i=0x8e;
 goto _bw;

/*************************************************************/
_blkb:
 get_operand(operand);
 if (! get_w(operand,&li)) ende(59,10);
 get_operand(operand);
 if (! *operand) {*lab_wert += li; blk_flag=1; goto nextline;}
 if (get_wert(operand,&lj) != 1) ende(90,4);
 i=12;
 for (;li>0;li--)  aus_byte((int)lj);
 goto nextline;
 

_blkl:
 get_operand(operand);
 if (! get_w(operand,&li)) ende(60,10);
 get_operand(operand);
 if (! *operand) {*lab_wert += li*4; blk_flag=1; goto nextline;}
 get_wert(operand,&lj);
 for (;li>0;li--)  aus_long(lj);
 goto nextline;


_blkw:
 get_operand(operand);
 if (! get_w(operand,&li)) ende(61,10);
 get_operand(operand);
 if (! *operand) {*lab_wert += li*2; blk_flag=1; goto nextline;}
 if (get_wert(operand,&lj) > 2) ende(90,4);
 for (;li>0;li--)  aus_word((int)lj);
 goto nextline;


/*************************************************************/
_blsb:
 i=0x76;
 goto _bb;

_blsl:
 i=0x86;
 goto _bl;

_blsw:
 i=0x86;
 goto _bw;

/*************************************************************/
_bltb:
 i=0x7c;
 goto _bb;

_bltl:
 i=0x8c;
 goto _bl;

_bltw:
 i=0x8c;
 goto _bw;

/*************************************************************/
_bmib:
 i=0x78;
 goto _bb;

_bmil:
 i=0x88;
 goto _bl;

_bmiw:
 i=0x88;
 goto _bw;

/*************************************************************/
_bneb:
 i=0x75;
 goto _bb;

_bnel:
 i=0x85;
 goto _bl;

_bnew:
 i=0x85;
 goto _bw;

/*************************************************************/
_bpcb:
 i=0x7b;
 goto _bb;

_bpcl:
 i=0x8b;
 goto _bl;

_bpcw:
 i=0x8b;
 goto _bw;

/*************************************************************/
_bplb:
 i=0x79;
 goto _bb;

_bpll:
 i=0x89;
 goto _bl;

_bplw:
 i=0x89;
 goto _bw;

/*************************************************************/
_bpsb:
 i=0x7a;
 goto _bb;

_bpsl:
 i=0x8a;
 goto _bl;

_bpsw:
 i=0x8a;
 goto _bw;

/*************************************************************/
_brb:
 i=0xeb;
 goto _bb;

/*************************************************************/
_brl:
 get_operand(operand);
 get_wert(operand,&li);
 if (!seg32) aus_byte(0x66);
 aus_byte(0xe9);
 li -= *lab_wert+4;
 aus_long(li);
 goto nextline;

/*-----------------------------------------------------------*/
_brw:
 get_operand(operand);
 get_wert(operand,&li);
 if (seg32) aus_byte(0x66);
 aus_byte(0xe9);
 li -= *lab_wert + 2;
 if (pass2 && (li > max16 || li < min16) )
    ende(62,6);
 aus_word((int)li); 
 goto nextline;

/*************************************************************/
_bscfl:
 op32=1;
/*-----------------------------------------------------------*/
_bscfw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if ( op2.nr == 3 && op1.nr >= 3  && op1.nr <= 30)
   {adr_pre(&op1);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op1);
    aus_byte(0x0f);
    aus_byte(0xbc);
    mod_sib(op2.reg1,&op1);
    goto nextline;
   }

 ende(63,3);

/*************************************************************/
_bscrl:
 op32=1;
/*-----------------------------------------------------------*/
_bscrw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if ( op2.nr == 3 && op1.nr >= 3  && op1.nr <= 30)
   {adr_pre(&op1);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op1);
    aus_byte(0x0f);
    aus_byte(0xbd);
    mod_sib(op2.reg1,&op1);
    goto nextline;
   }

 ende(64,3);

/*************************************************************/
_bsetl:
 op32=1;
/*-----------------------------------------------------------*/
_bsetw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (op1.reg1 != 1) ende(65,4);
    if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x0f);
    aus_byte(0xba);
    mod__sib(5,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op2.nr >= 3 && op2.nr <= 30 )
   {if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x0f);
    aus_byte(0xab);
    mod_sib(op1.reg1,&op2);
    goto nextline;
   }

 if (op1.nr == 34  && op2.nr == 35)
   {if      (op1.konst == (long)  0 )  aus_byte(0xf9);
    else if (op1.konst == (long)  9 )  aus_byte(0xfb);
    else if (op1.konst == (long) 10 )  aus_byte(0xfd);
    else ende(66,3);
    goto nextline;
   }

 ende(67,3);

/*************************************************************/
_bsrl:
 op32=1;
/*-----------------------------------------------------------*/
_bsrw:
 get_operand(operand);
 get_wert(operand,&li);
 if (seg32 ^ op32) aus_byte(0x66);
 aus_byte(0xe8);

 li -= *lab_wert+2;
 if (op32) {li -= 2; aus_long(li);}
     else  {if (pass2 && (li > max16 || li < min16))
                ende(68,6);
            aus_word((int)li);
           }

 goto nextline;

/*************************************************************/
_bswapl:
 get_operand(operand);
 dec_operand(operand,&op1); 

 if ( op1.nr == 3 )
   {
    if (!seg32) aus_byte(0x66); /* als 16-Bit Befehl offiziell undefiniert
                     486 fuehr bswap aus, ueberschreibt aber nur r.w mit
                     dem Ergebnis und laesst hoeheres Wort unveraendert. */
    aus_byte(0x0f);
    aus_byte(0xc8 | trans(op1.reg1));
    goto nextline;
   }

 ende(69,3);


/*************************************************************/
_btstl:
 op32=1;
/*-----------------------------------------------------------*/
_btstw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (op1.reg1 != 1) ende(70,4);
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x0f);
    aus_byte(0xba);
    mod__sib(4,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x0f);
    aus_byte(0xa3);
    mod_sib(op1.reg1,&op2);
    goto nextline;
   }

 ende(71,3);

/*************************************************************/
_bvcb:
 i=0x71;
 goto _bb;

_bvcl:
 i=0x81;
 goto _bl;

_bvcw:
 i=0x81;
 goto _bw;

/*************************************************************/
_bvsb:
 i=0x70;
 goto _bb;

_bvsl:
 i=0x80;
 goto _bl;

_bvsw:
 i=0x80;
 goto _bw;

/*************************************************************/
_casb:
 get_operand(operand);
 dec_operand(operand,&op1); 
 if (op1.nr != 3  || op1.reg1 != 0) ende(72,3);

 get_operand(operand);
 dec_boperand(operand,&op1); 
 get_operand(operand);
 dec_boperand(operand,&op2); 

 if ( op1.nr == 3 && op2.nr >= 3 && op2.nr <= 30 )
   {if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0x0f);
    aus_byte(0xb0);
    mod_sib(op1.reg1,&op2);
    goto nextline;
   }

 ende(73,3);

/*************************************************************/
_casl:
 op32=1;

/*-----------------------------------------------------------*/
_casw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 if (op1.nr != 3  || op1.reg1 != 0) ende(74,3);

 get_operand(operand);
 dec_boperand(operand,&op1); 
 get_operand(operand);
 dec_boperand(operand,&op2); 

 if ( op1.nr == 3 && op2.nr >= 3 && op2.nr <= 30 )
   {if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x0f);
    aus_byte(0xb1);
    mod_sib(op1.reg1,&op2);
    goto nextline;
   }

 ende(75,3);

/*************************************************************/
_chkl:
 op32=1;
/*-----------------------------------------------------------*/
_chkw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if ( op1.nr == 3 && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x62);
    mod_sib(op1.reg1,&op2);
    goto nextline;
   }

 ende(76,3);

/*************************************************************/
_cmpb:
 get_operand(operand);
 dec_boperand(operand,&op1); 
 get_operand(operand);
 dec_boperand(operand,&op2); 

 if (op1.nr == 34  && op2.nr == 3 && op2.reg1 == 0)
   {if (op1.reg1 != 1) ende(77,4);
    aus_byte(0x3c);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (op1.reg1 != 1) ende(78,4);
    adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0x80);
    mod__sib(7,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0x38);
    mod_sib(op1.reg1,&op2);
    goto nextline;
   }

 if ( op2.nr == 3 && op1.nr >= 3  && op1.nr <= 30)
   {adr_pre(&op1);
    seg_pre(&op1);
    aus_byte(0x3a);
    mod_sib(op2.reg1,&op1);
    goto nextline;
   }

 if ( op1.nr == 43 && op2.nr == 45 || op1.nr == 44 && op2.nr == 46 )
   {if      (op_pref == 2) {aus_byte(0xf3); op_pref=0;}
    else if (op_pref == 3) {aus_byte(0xf2); op_pref=0;}
    adr_pre(&op1);
    seg_pre(&op2);
    aus_byte(0xa6);
    goto nextline;
   }

 if ( (op1.nr == 43 || op1.nr == 44) && op2.nr == 3 && op2.reg1 == 0 )
   {if      (op_pref == 2) {aus_byte(0xf3); op_pref=0;}
    else if (op_pref == 3) {aus_byte(0xf2); op_pref=0;}
    adr_pre(&op1);
    aus_byte(0xae);
    goto nextline;
   }

 ende(79,3);

/*************************************************************/
_cmpl:
 op32=1;
/*-----------------------------------------------------------*/
_cmpw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr == 34  && op2.nr == 3 && op2.reg1 == 0)
   {if (!op32 && op1.reg1 > 2) ende(80,5);
    if (seg32 ^ op32) aus_byte(0x66);
    aus_byte(0x3d);
    if (! op32) aus_word((int)op1.konst); else aus_long(op1.konst);
    goto nextline;
   }

 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (!op32 && op1.reg1 > 2) ende(81,5);
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x81);
    mod__sib(7,&op2);
    if (! op32) aus_word((int)op1.konst); else aus_long(op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x39);
    mod_sib(op1.reg1,&op2);
    goto nextline;
   }

 if ( op2.nr == 3 && op1.nr >= 3  && op1.nr <= 30)
   {adr_pre(&op1);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op1);
    aus_byte(0x3b);
    mod_sib(op2.reg1,&op1);
    goto nextline;
   }

 if ( op1.nr == 43 && op2.nr == 45 || op1.nr == 44 && op2.nr == 46 )
   {if      (op_pref == 2) {aus_byte(0xf3); op_pref=0;}
    else if (op_pref == 3) {aus_byte(0xf2); op_pref=0;}
    adr_pre(&op1);
    seg_pre(&op2);
    aus_byte(0xa7);
    goto nextline;
   }

 if ( (op1.nr == 43 || op1.nr == 44) && op2.nr == 3 && op2.reg1 == 0 )
   {if      (op_pref == 2) {aus_byte(0xf3); op_pref=0;}
    else if (op_pref == 3) {aus_byte(0xf2); op_pref=0;}
    adr_pre(&op1);
    aus_byte(0xaf);
    goto nextline;
   }

 ende(82,3);

/*************************************************************/
_cmpql:
 op32=1;
/*-----------------------------------------------------------*/
_cmpqw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (op1.reg1 != 1) ende(83,4);
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x83);
    mod__sib(7,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 ende(84,3);




/*************************************************************/
_dbeql:
 op32=1;
/*-----------------------------------------------------------*/
_dbeqw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 if (op1.nr != 3 || op1.reg1 != 2) ende(85,3);
 if (seg32 ^ op32) aus_byte(0x67);
 i=0xe0;
 goto _bb;

/*************************************************************/
_dbfl:
 op32=1;
/*-----------------------------------------------------------*/
_dbfw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 if (op1.nr != 3 || op1.reg1 != 2) ende(86,3);
 if (seg32 ^ op32) aus_byte(0x67);
 i=0xe2;
 goto _bb;


/*************************************************************/
_dbnel:
 op32=1;
/*-----------------------------------------------------------*/
_dbnew:
 get_operand(operand);
 dec_operand(operand,&op1); 
 if (op1.nr != 3 || op1.reg1 != 2) ende(87,3);
 if (seg32 ^ op32) aus_byte(0x67);
 i=0xe1;
 goto _bb;

/*************************************************************/
_dcb:
 while (1)
  {get_operand(operand);
   if (! *operand) goto nextline;

   if ( (i = *operand) == '\'' || i == '"')
      {q=operand+1;
       while (*q != i) if (! *q++) ende(88,25);
       if (! *++q)
          {q=operand+1;
           while (*q != i) aus_byte(*q++);
           continue;
          }
      }
   if (get_wert(operand,&li) != 1) ende(90,4);
   aus_byte((int)li);
  }

_dcbw:
 while (1)
  {get_operand(operand);
   if (! *operand) goto nextline;

   if ( (i = *operand) == '\'' || i == '"')
      {q=operand+1;
       while (*q != i) if (! *q++) ende(88,25);
       if (! *++q)
          {q=operand+1;
           while (*q != i) {aus_byte(*q++); aus_byte(0);}
           continue;
          }
      }
   if (get_wert(operand,&li) != 1) ende(90,4);
   aus_byte((int)li); aus_byte(0);
  }

_dcl:
 while (1)
  {get_operand(operand);
   if (! *operand) goto nextline;
   get_wert(operand,&li);
   aus_long(li);
  }

_dcw:
 while (1)
  {get_operand(operand);
   if (! *operand) goto nextline;
   if (get_wert(operand,&li) > 2) ende(91,4);
       aus_word((int)li);
  }

_dcl_:
 while (1)
  {get_operand(operand);
   if (! *operand) goto nextline;
   get_wert(operand,&li);
   li=(li>>24) + ((li>>8)&0xff00) +((li<<8)&0xff0000) +(li<<24);
   aus_long(li);
  }

_dcw_:
 while (1)
  {get_operand(operand);
   if (! *operand) goto nextline;
   if (get_wert(operand,&li) > 2) ende(91,4);
   li=((li>>8)&0x00ff) +(li<<8);
       aus_word((int)li);
  }

/*************************************************************/
_decb:
 get_operand(operand);
 dec_boperand(operand,&op1); 

 if (op1.nr >= 3 && op1.nr <= 30)
   {if (op1.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op1);
    seg_pre(&op1);
    aus_byte(0xfe);
    mod__sib(1,&op1);
    goto nextline;
   }

 ende(92,3);

/*************************************************************/
_decl:
 op32=1;
/*-----------------------------------------------------------*/
_decw:
 get_operand(operand);
 dec_operand(operand,&op1); 

 if (op1.nr == 3 )
   {if (seg32 ^ op32) aus_byte(0x66);
    aus_byte(0x48+trans(op1.reg1));
    goto nextline;
   }

 if ( op1.nr >= 4 && op1.nr <= 30)
   {if (op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op1);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op1);
    aus_byte(0xff);
    mod__sib(1,&op1);
    goto nextline;
   }

 ende(93,3);

/*************************************************************/
_divsb:
 get_operand(operand);
 dec_boperand(operand,&op1); 
 get_operand(operand);
 dec_boperand(operand,&op2); 

 if ( op1.nr >= 3 && op1.nr <= 30 && op2.nr == 48 )
   {adr_pre(&op1);
    seg_pre(&op1);
    aus_byte(0xf6);
    mod__sib(7,&op1);
    goto nextline;
   }

 ende(94,3);

/*************************************************************/
_divsl:
 op32=1;
/*-----------------------------------------------------------*/
_divsw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if ( op1.nr >= 3 && op1.nr <= 30 && op2.nr == 47 )
   {adr_pre(&op1);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op1);
    aus_byte(0xf7);
    mod__sib(7,&op1);
    goto nextline;
   }

 ende(95,3);

/*************************************************************/
_divub:
 get_operand(operand);
 dec_boperand(operand,&op1); 
 get_operand(operand);
 dec_boperand(operand,&op2); 

 if ( op1.nr >= 3 && op1.nr <= 30 && op2.nr == 48 )
   {adr_pre(&op1);
    seg_pre(&op1);
    aus_byte(0xf6);
    mod__sib(6,&op1);
    goto nextline;
   }

 ende(96,3);

/*************************************************************/
_divul:
 op32=1;
/*-----------------------------------------------------------*/
_divuw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if ( op1.nr >= 3 && op1.nr <= 30 && op2.nr == 47 )
   {adr_pre(&op1);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op1);
    aus_byte(0xf7);
    mod__sib(6,&op1);
    goto nextline;
   }

 ende(97,3);


/*************************************************************/
_dsll:
 op32=1;
/*-----------------------------------------------------------*/
_dslw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);

 i=0; while (operand[i++]); i-=4; p=operand+i;
 if (i<=0 || *p != '<' ) ende(98,3);
 *p++ = 0;
 q=opcode;
 while (*q++ = *p++);

 dec_operand(operand,&op2); 
 dec_operand(opcode,&op3); 

 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30 && op3.nr == 3)
   {if (op1.reg1 != 1) ende(99,5);
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x0f);
    aus_byte(0xa4);
    mod_sib(op3.reg1,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if (op1.nr==3 && op1.reg1==2 && op2.nr>=3 && op2.nr<=30 && op3.nr== 3)
   {adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x0f);
    aus_byte(0xa5);
    mod_sib(op3.reg1,&op2);
    goto nextline;
   }

 ende(100,3);


/*************************************************************/
_dsrl:
 op32=1;
/*-----------------------------------------------------------*/
_dsrw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);

 i=0; while (operand[i++]); p=operand+2;
 if (i<=4 || *p != '>' ) ende(101,3);
 *p++ = 0;
 q=opcode;
 while (*q++ = *p++);

 dec_operand(operand,&op3); 
 dec_operand(opcode,&op2); 

 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30 && op3.nr == 3)
   {if (op1.reg1 != 1) ende(102,5);
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x0f);
    aus_byte(0xac);
    mod_sib(op3.reg1,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if (op1.nr==3 && op1.reg1==2 && op2.nr>=3 && op2.nr<=30 && op3.nr== 3)
   {adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x0f);
    aus_byte(0xad);
    mod_sib(op3.reg1,&op2);
    goto nextline;
   }

 ende(103,3);

/*************************************************************/
_eorb:
 get_operand(operand);
 dec_boperand(operand,&op1); 
 get_operand(operand);
 dec_boperand(operand,&op2); 

 if (op1.nr == 34  && op2.nr == 3 && op2.reg1 == 0)
   {if (op1.reg1 != 1) ende(104,4);
    aus_byte(0x34);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (op1.reg1 != 1) ende(105,4);
    if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0x80);
    mod__sib(6,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op2.nr >= 3 && op2.nr <= 30 )
   {if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0x30);
    mod_sib(op1.reg1,&op2);
    goto nextline;
   }

 if ( op2.nr == 3 && op1.nr >= 3  && op1.nr <= 30)
   {
    adr_pre(&op1);
    seg_pre(&op1);
    aus_byte(0x32);
    mod_sib(op2.reg1,&op1);
    goto nextline;
   }

 ende(106,3);

/*************************************************************/
_eorl:
 op32=1;
/*-----------------------------------------------------------*/
_eorw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr == 34  && op2.nr == 3 && op2.reg1 == 0)
   {if (!op32 && op1.reg1 > 2) ende(107,5);
    if (seg32 ^ op32) aus_byte(0x66);
    aus_byte(0x35);
    if (! op32) aus_word((int)op1.konst); else aus_long(op1.konst);
    goto nextline;
   }

 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (!op32 && op1.reg1 > 2) ende(108,5);
    if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x81);
    mod__sib(6,&op2);
    if (! op32) aus_word((int)op1.konst); else aus_long(op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op2.nr >= 3 && op2.nr <= 30 )
   {if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x31);
    mod_sib(op1.reg1,&op2);
    goto nextline;
   }

 if ( op2.nr == 3 && op1.nr >= 3  && op1.nr <= 30)
   {
    adr_pre(&op1);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op1);
    aus_byte(0x33);
    mod_sib(op2.reg1,&op1);
    goto nextline;
   }

 ende(109,3);

/*************************************************************/
_eorql:
 op32=1;
/*-----------------------------------------------------------*/
_eorqw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (op1.reg1 != 1) ende(110,4);
    if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x83);
    mod__sib(6,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 ende(111,3);


/*************************************************************/
_even:
 li=2; lj=0;
 get_operand(operand);
 if (*operand) 
    {if (! get_w(operand,&li)) ende(500,10);
     get_operand(operand);
     if (*operand) if (get_wert(operand,&lj) != 1) ende (501,4);
    }
 if (lk = *lab_wert%li) for (;lk<li;lk++) aus_byte((int)lj);
 goto nextline;
  
_even4:
 i = ( *lab_wert & (long) 0x03 );
 if (i) i = 4-i;
 while (i--) aus_byte(0x00);
 goto nextline;

_even16:
 i = ( *lab_wert & (long) 0x0f );
 if (i) i = 16-i;
 while (i--) aus_byte(0x00);
 goto nextline;

_evencom:
 li=2; lj=0;
 get_operand(operand);
 if (*operand) 
    {if (! get_w(operand,&li)) ende(505,10);
     get_operand(operand);
     if (*operand) if (get_wert(operand,&lj) != 1) ende (501,4);
    }
 if (lk = lab_wert[1]%li) for (;lk<li;lk++) aus_byte((int)lj);
 goto nextline;

/*************************************************************/
_exgb:
 get_operand(operand);
 dec_boperand(operand,&op1); 
 get_operand(operand);
 dec_boperand(operand,&op2); 

 if ( op1.nr == 3 && op2.nr >= 3 && op2.nr <= 30 )
   {if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0x86);
    mod_sib(op1.reg1,&op2);
    goto nextline;
   }

 if ( op2.nr == 3 && op1.nr >= 3  && op1.nr <= 30)
   {
    adr_pre(&op1);
    seg_pre(&op1);
    aus_byte(0x86);
    mod_sib(op2.reg1,&op1);
    goto nextline;
   }

 ende(112,3);

/*************************************************************/
_exgl:
 op32=1;
/*-----------------------------------------------------------*/
_exgw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr == 3 && op1.reg1 == 0  && op2.nr == 3)
   {if (seg32 ^ op32) aus_byte(0x66);
    aus_byte(0x90+trans(op2.reg1));
    goto nextline;
   }

 if (op2.nr == 3 && op2.reg1 == 0  && op1.nr == 3)
   {if (seg32 ^ op32) aus_byte(0x66);
    aus_byte(0x90+trans(op1.reg1));
    goto nextline;
   }

 if ( op1.nr == 3 && op2.nr >= 3 && op2.nr <= 30 )
   {if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x87);
    mod_sib(op1.reg1,&op2);
    goto nextline;
   }

 if ( op2.nr == 3 && op1.nr >= 3  && op1.nr <= 30)
   {
    adr_pre(&op1);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op1);
    aus_byte(0x87);
    mod_sib(op2.reg1,&op1);
    goto nextline;
   }

 ende(113,3);

/*************************************************************/
_extl:
 op32=1;
/*-----------------------------------------------------------*/
_extw:
 if (seg32 ^ op32) aus_byte(0x66);
 get_operand(operand);
 if (! cmps(operand,"r0")) ende(114,3);
 get_operand(operand);
 if (!*operand) {aus_byte(0x98); goto nextline;}
 if (! cmps(operand,"r1|r0")) ende(115,3);
 aus_byte(0x99);
 goto nextline;

/*************************************************************/
_halt:
 aus_byte(0xf4);
 goto nextline;

/*************************************************************/
_inb:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr == 34  && op2.nr == 3 && op2.reg1 == 0)
   {if (op1.reg1 != 1) ende(116,4);
    aus_byte(0xe4);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if (op1.nr == 3 && op1.reg1 == 1  && op2.nr == 3 && op2.reg1 == 0)
   {aus_byte(0xec);
    goto nextline;
   }

 if ( op1.nr == 3 && op1.reg1 == 1 && (op2.nr == 43 || op2.nr == 44) )
   {if      (op_pref == 1) {aus_byte(0xf3); op_pref=0;}
    adr_pre(&op2);
    aus_byte(0x6c);
    goto nextline;
   }
 ende(117,3);


/*************************************************************/
_inl:
 op32=1;
/*-----------------------------------------------------------*/
_inw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr == 34  && op2.nr == 3 && op2.reg1 == 0)
   {if (op1.reg1 != 1) ende(118,4);
    if (seg32 ^ op32) aus_byte(0x66);
    aus_byte(0xe5);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if (op1.nr == 3 && op1.reg1 == 1  && op2.nr == 3 && op2.reg1 == 0)
   {if (seg32 ^ op32) aus_byte(0x66);
    aus_byte(0xed);
    goto nextline;
   }

 if ( op1.nr == 3 && op1.reg1 == 1 && (op2.nr == 43 || op2.nr == 44) )
   {if      (op_pref == 1) {aus_byte(0xf3); op_pref=0;}
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    aus_byte(0x6d);
    goto nextline;
   }
 ende(119,3);

/*************************************************************/
_incb:
 get_operand(operand);
 dec_boperand(operand,&op1); 

 if (op1.nr >= 3 && op1.nr <= 30)
   {if (op1.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op1);
    seg_pre(&op1);
    aus_byte(0xfe);
    mod__sib(0,&op1);
    goto nextline;
   }

 ende(120,3);

/*************************************************************/
_incl:
 op32=1;
/*-----------------------------------------------------------*/
_incw:
 get_operand(operand);
 dec_operand(operand,&op1); 

 if (op1.nr == 3 )
   {if (seg32 ^ op32) aus_byte(0x66);
    aus_byte(0x40+trans(op1.reg1));
    goto nextline;
   }

 if ( op1.nr >= 4 && op1.nr <= 30)
   {if (op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op1);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op1);
    aus_byte(0xff);
    mod__sib(0,&op1);
    goto nextline;
   }

 ende(121,3);

/*************************************************************/
_invlcache:
 aus_byte(0x0f);
 aus_byte(0x08);
 goto nextline;

/*************************************************************/
_invlwb:
 aus_byte(0x0f);
 aus_byte(0x09);
 goto nextline;

/*************************************************************/
_invltbl:
 get_operand(operand);
 dec_operand(operand,&op1); 

 if ( op1.nr >= 4 && op1.nr <= 30)
   {adr_pre(&op1);
    seg_pre(&op1);
    aus_byte(0x0f);
    aus_byte(0x01);
    mod__sib(7,&op1);
    goto nextline;
   }

 ende(122,3);

/*************************************************************/
_jmpl:
 op32=1;
/*-----------------------------------------------------------*/
_jmpw:
 get_operand(operand);

 i=0; while (operand[i++]); i-=2;
 if (i<=0 || operand[0] != '(' || operand[i] != ')' ) ende(123,3);
 operand[i] = 0;

 dec_operand(operand+1,&op1); 

 if (op1.nr >= 3  && op1.nr <= 30)
   {adr_pre(&op1);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op1);
    aus_byte(0xff);
    mod__sib(4,&op1);
    goto nextline;
   }

 ende(124,3);

/*************************************************************/
_jmpwl:
 op32=1;
/*-----------------------------------------------------------*/
_jmpww:
 get_operand(operand);

 if (*operand == '(' )
    {i=0; while (operand[i++]); i-=2;
     if (i<=0 || operand[i] != ')' ) ende(125,3);
     operand[i] = 0;

     dec_operand(operand+1,&op1); 

     if (op1.nr < 4  || op1.nr > 30) ende(126,3);
     adr_pre(&op1);
     if (seg32 ^ op32) aus_byte(0x66);
     seg_pre(&op1);
     aus_byte(0xff);
     mod__sib(5,&op1);
     goto nextline;
    }

 p=operand; 
 while (*p != ':') if (! *p++ ) ende(127,3);
 *p++ = 0;

 if (seg32 ^ op32) aus_byte(0x66);
 aus_byte(0xea);

 get_wert(p,&li); 
 if (!op32) {if (li > high16 || li < low16 )ende(128,5);
              aus_word( (int) li);
             }
    else aus_long(li);

 get_wert(operand,&li); 
 if (li > high16 || li < low16 )ende(129,5);
 aus_word( (int) li );

 goto nextline;

/*************************************************************/
_jsrl:
 op32=1;
/*-----------------------------------------------------------*/
_jsrw:
 get_operand(operand);

 i=0; while (operand[i++]); i-=2;
 if (i<=0 || operand[0] != '(' || operand[i] != ')' ) ende(130,3);
 operand[i] = 0;

 dec_operand(operand+1,&op1); 

 if (op1.nr >= 3  && op1.nr <= 30)
   {adr_pre(&op1);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op1);
    aus_byte(0xff);
    mod__sib(2,&op1);
    goto nextline;
   }

 ende(132,3);



/*************************************************************/
_jsrwl:
 op32=1;
/*-----------------------------------------------------------*/
_jsrww:
 get_operand(operand);

 if (*operand == '(' )
    {i=0; while (operand[i++]); i-=2;
     if (i<=0 || operand[i] != ')' ) ende(133,3);
     operand[i] = 0;

     dec_operand(operand+1,&op1); 

     if (op1.nr < 4  || op1.nr > 30) ende(134,3);
     adr_pre(&op1);
     if (seg32 ^ op32) aus_byte(0x66);
     seg_pre(&op1);
     aus_byte(0xff);
     mod__sib(3,&op1);
     goto nextline;
    }

 p=operand; 
 while (*p != ':') if (! *p++ ) ende(135,3);
 *p++ = 0;

 if (seg32 ^ op32) aus_byte(0x66);
 aus_byte(0x9a);

 get_wert(p,&li); 
 if (!op32) {if (li > high16 || li < low16 )ende(136,5);
              aus_word( (int) li);
             }
    else aus_long(li);

 get_wert(operand,&li); 
 if (li > high16 || li < low16 ) ende(137,5);
 aus_word( (int) li );

 goto nextline;

/*************************************************************/
_linkl:
 op32=1;
/*-----------------------------------------------------------*/
_linkw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 
 get_operand(operand);
 dec_operand(operand,&op3); 
 
 if (op1.nr!=3 || op1.reg1!=4 || op2.nr!=34 || op3.nr!=34) ende(138,3);
 if (!op32 && op2.reg1 > 2) ende(139,5);
 if (op3.konst < (long) 0 || op3.konst > (long) 31) ende(140,4);
 if (seg32 ^ op32) aus_byte(0x66);
 aus_byte(0xc8);
 aus_word((int)op2.konst);
 aus_byte((int)op3.konst);
 goto nextline;

/*************************************************************/
_larl:
 op32=1;
/*-----------------------------------------------------------*/
_larw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if ( op1.nr == 3 && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x0f);
    aus_byte(0x02);
    mod_sib(op1.reg1,&op2);
    goto nextline;
   }

 ende(141,3);


/*************************************************************/
_ldsll:
 op32=1;
/*-----------------------------------------------------------*/
_ldslw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if ( op2.nr == 3 && op1.nr >= 3 && op1.nr <= 30 )
   {adr_pre(&op1);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op1);
    aus_byte(0x0f);
    aus_byte(0x03);
    mod_sib(op2.reg1,&op1);
    goto nextline;
   }

 ende(142,3);

/*************************************************************/
_leal:
 op32=1;
/*-----------------------------------------------------------*/
_leaw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if ( op2.nr == 3 && op1.nr >= 3 && op1.nr <= 30 )
   {adr_pre(&op1);
    if (seg32 ^ op32) aus_byte(0x66);
    aus_byte(0x8d);
    mod_sib(op2.reg1,&op1);
    goto nextline;
   }

 ende(143,3);

/*************************************************************/
_list:
 list_level++;
 goto nextline;

/*************************************************************/
/*************************************************************/

#if rechner==atari
nextline: goto nextl1; /* sonst Sprung > 32k */
#endif

/*************************************************************/
/*************************************************************/


op__:
 p=opcode;
 while (*++p);
 *opcode = *--p;
 *p=0;
 if (opcode[0]=='_') j=1; 
 get_operand(operand);
 i=get_w(operand,&li); 
 if (!i) j = -j;
 ins_lab(opcode,li,j);
 goto nextline;

op_a:
 if (cmps(opcode,"add.b"))      goto _addb;
 if (cmps(opcode,"add.l"))      goto _addl;
 if (cmps(opcode,"add.w"))      goto _addw;
 if (cmps(opcode,"addc.b"))     goto _addcb;
 if (cmps(opcode,"addc.l"))     goto _addcl;
 if (cmps(opcode,"addc.w"))     goto _addcw;
 if (cmps(opcode,"addcq.l"))    goto _addcql;
 if (cmps(opcode,"addcq.w"))    goto _addcqw;
 if (cmps(opcode,"addq.l"))     goto _addql;
 if (cmps(opcode,"addq.w"))     goto _addqw;
 if (cmps(opcode,"adj_asc_add")) goto _aaadd;
 if (cmps(opcode,"adj_asc_div")) goto _aadiv;
 if (cmps(opcode,"adj_asc_mul")) goto _aamul;
 if (cmps(opcode,"adj_asc_sub")) goto _aaasub;
 if (cmps(opcode,"adj_dec_add")) goto _adadd;
 if (cmps(opcode,"adj_dec_sub")) goto _adsub;
 if (cmps(opcode,"and.b"))      goto _andb;
 if (cmps(opcode,"and.l"))      goto _andl;
 if (cmps(opcode,"and.w"))      goto _andw;
 if (cmps(opcode,"andq.l"))     goto _andql;
 if (cmps(opcode,"andq.w"))     goto _andqw;
 if (cmps(opcode,"arpl.w"))     goto _arplw;
 if (cmps(opcode,"asl.b"))      goto _aslb;
 if (cmps(opcode,"asl.l"))      goto _asll;
 if (cmps(opcode,"asl.w"))      goto _aslw;
 if (cmps(opcode,"asr.b"))      goto _asrb;
 if (cmps(opcode,"asr.l"))      goto _asrl;
 if (cmps(opcode,"asr.w"))      goto _asrw;
 ende(145,1);

op_b:
 if (cmps(opcode,"bcc.b"))      goto _bccb;
 if (cmps(opcode,"bcc.l"))      goto _bccl;
 if (cmps(opcode,"bcc.w"))      goto _bccw;
 if (cmps(opcode,"bcs.b"))      goto _bcsb;
 if (cmps(opcode,"bcs.l"))      goto _bcsl;
 if (cmps(opcode,"bcs.w"))      goto _bcsw;
 if (cmps(opcode,"bchg.l"))     goto _bchgl;
 if (cmps(opcode,"bchg.w"))     goto _bchgw;
 if (cmps(opcode,"bclr.l"))     goto _bclrl;
 if (cmps(opcode,"bclr.w"))     goto _bclrw;
 if (cmps(opcode,"beq.b"))      goto _beqb;
 if (cmps(opcode,"beq.l"))      goto _beql;
 if (cmps(opcode,"beq.w"))      goto _beqw;
 if (cmps(opcode,"beqr2l.b"))   goto _beqr2lb;
 if (cmps(opcode,"beqr2w.b"))   goto _beqr2wb;
 if (cmps(opcode,"bge.b"))      goto _bgeb;
 if (cmps(opcode,"bge.l"))      goto _bgel;
 if (cmps(opcode,"bge.w"))      goto _bgew;
 if (cmps(opcode,"bgt.b"))      goto _bgtb;
 if (cmps(opcode,"bgt.l"))      goto _bgtl;
 if (cmps(opcode,"bgt.w"))      goto _bgtw;
 if (cmps(opcode,"bhi.b"))      goto _bhib;
 if (cmps(opcode,"bhi.l"))      goto _bhil;
 if (cmps(opcode,"bhi.w"))      goto _bhiw;
 if (cmps(opcode,"bhs.b"))      goto _bccb;
 if (cmps(opcode,"bhs.l"))      goto _bccl;
 if (cmps(opcode,"bhs.w"))      goto _bccw;
 if (cmps(opcode,"ble.b"))      goto _bleb;
 if (cmps(opcode,"ble.l"))      goto _blel;
 if (cmps(opcode,"ble.w"))      goto _blew;
 if (cmps(opcode,"blk.b"))      goto _blkb;
 if (cmps(opcode,"blk.l"))      goto _blkl;
 if (cmps(opcode,"blk.w"))      goto _blkw;
 if (cmps(opcode,"blo.b"))      goto _bcsb;
 if (cmps(opcode,"blo.l"))      goto _bcsl;
 if (cmps(opcode,"blo.w"))      goto _bcsw;
 if (cmps(opcode,"bls.b"))      goto _blsb;
 if (cmps(opcode,"bls.l"))      goto _blsl;
 if (cmps(opcode,"bls.w"))      goto _blsw;
 if (cmps(opcode,"blt.b"))      goto _bltb;
 if (cmps(opcode,"blt.l"))      goto _bltl;
 if (cmps(opcode,"blt.w"))      goto _bltw;
 if (cmps(opcode,"bmi.b"))      goto _bmib;
 if (cmps(opcode,"bmi.l"))      goto _bmil;
 if (cmps(opcode,"bmi.w"))      goto _bmiw;
 if (cmps(opcode,"bne.b"))      goto _bneb;
 if (cmps(opcode,"bne.l"))      goto _bnel;
 if (cmps(opcode,"bne.w"))      goto _bnew;
 if (cmps(opcode,"bpc.b"))      goto _bpcb;
 if (cmps(opcode,"bpc.l"))      goto _bpcl;
 if (cmps(opcode,"bpc.w"))      goto _bpcw;
 if (cmps(opcode,"bpl.b"))      goto _bplb;
 if (cmps(opcode,"bpl.l"))      goto _bpll;
 if (cmps(opcode,"bpl.w"))      goto _bplw;
 if (cmps(opcode,"bps.b"))      goto _bpsb;
 if (cmps(opcode,"bps.l"))      goto _bpsl;
 if (cmps(opcode,"bps.w"))      goto _bpsw;
 if (cmps(opcode,"br.b"))       goto _brb;
 if (cmps(opcode,"br.l"))       goto _brl;
 if (cmps(opcode,"br.w"))       goto _brw;
 if (cmps(opcode,"bscf.l"))     goto _bscfl;
 if (cmps(opcode,"bscf.w"))     goto _bscfw;
 if (cmps(opcode,"bscr.l"))     goto _bscrl;
 if (cmps(opcode,"bscr.w"))     goto _bscrw;
 if (cmps(opcode,"bset.l"))     goto _bsetl;
 if (cmps(opcode,"bset.w"))     goto _bsetw;
 if (cmps(opcode,"bsr.w"))      goto _bsrw;
 if (cmps(opcode,"bsr.l"))      goto _bsrl;
 if (cmps(opcode,"bswap.l"))    goto _bswapl;
 if (cmps(opcode,"btst.l"))     goto _btstl;
 if (cmps(opcode,"btst.w"))     goto _btstw;
 if (cmps(opcode,"bvc.b"))      goto _bvcb;
 if (cmps(opcode,"bvc.l"))      goto _bvcl;
 if (cmps(opcode,"bvc.w"))      goto _bvcw;
 if (cmps(opcode,"bvs.b"))      goto _bvsb;
 if (cmps(opcode,"bvs.l"))      goto _bvsl;
 if (cmps(opcode,"bvs.w"))      goto _bvsw;
 ende(146,1);

op_c:
 if (cmps(opcode,"cas.b"))      goto _casb;
 if (cmps(opcode,"cas.l"))      goto _casl;
 if (cmps(opcode,"cas.w"))      goto _casw;
 if (cmps(opcode,"chk.l"))      goto _chkl;
 if (cmps(opcode,"chk.w"))      goto _chkw;
 if (cmps(opcode,"cmp.b"))      goto _cmpb;
 if (cmps(opcode,"cmp.l"))      goto _cmpl;
 if (cmps(opcode,"cmp.w"))      goto _cmpw;
 if (cmps(opcode,"cmpq.l"))     goto _cmpql;
 if (cmps(opcode,"cmpq.w"))     goto _cmpqw;
 ende(147,1);

op_d:
 if (cmps(opcode,"dbeq.l"))     goto _dbeql;
 if (cmps(opcode,"dbeq.w"))     goto _dbeqw;
 if (cmps(opcode,"dbf.l"))      goto _dbfl;
 if (cmps(opcode,"dbf.w"))      goto _dbfw;
 if (cmps(opcode,"dbne.l"))     goto _dbnel;
 if (cmps(opcode,"dbne.w"))     goto _dbnew;
 if (cmps(opcode,"dc.b"))       goto _dcb;
 if (cmps(opcode,"dc.bw"))      goto _dcbw;
 if (cmps(opcode,"dc.l"))       goto _dcl;
 if (cmps(opcode,"dc.l_"))      goto _dcl_;
 if (cmps(opcode,"dc.w"))       goto _dcw;
 if (cmps(opcode,"dc.w_"))      goto _dcw_;
 if (cmps(opcode,"dec.b"))      goto _decb;
 if (cmps(opcode,"dec.l"))      goto _decl;
 if (cmps(opcode,"dec.w"))      goto _decw;
 if (cmps(opcode,"divs.b"))     goto _divsb;
 if (cmps(opcode,"divs.l"))     goto _divsl;
 if (cmps(opcode,"divs.w"))     goto _divsw;
 if (cmps(opcode,"divu.b"))     goto _divub;
 if (cmps(opcode,"divu.l"))     goto _divul;
 if (cmps(opcode,"divu.w"))     goto _divuw;
 if (cmps(opcode,"dsl.l"))      goto _dsll;
 if (cmps(opcode,"dsl.w"))      goto _dslw;
 if (cmps(opcode,"dsr.l"))      goto _dsrl;
 if (cmps(opcode,"dsr.w"))      goto _dsrw;
 ende(148,1);

op_e:
 if (cmps(opcode,"eor.b"))      goto _eorb;
 if (cmps(opcode,"eor.l"))      goto _eorl;
 if (cmps(opcode,"eor.w"))      goto _eorw;
 if (cmps(opcode,"eorq.w"))     goto _eorqw;
 if (cmps(opcode,"eorq.l"))     goto _eorql;
 if (cmps(opcode,"even"))       goto _even;
 if (cmps(opcode,"even4"))      goto _even4;
 if (cmps(opcode,"even16"))     goto _even16;
 if (cmps(opcode,"evencom"))    goto _evencom;
 if (cmps(opcode,"exg.b"))      goto _exgb;
 if (cmps(opcode,"exg.l"))      goto _exgl;
 if (cmps(opcode,"exg.w"))      goto _exgw;
 if (cmps(opcode,"ext.l"))      goto _extl;
 if (cmps(opcode,"ext.w"))      goto _extw;
 ende(149,1);

op_f:
 ende(150,1);

op_g:
 ende(151,1);

op_h:
 if (cmps(opcode,"halt"))      goto _halt;
 ende(152,1);

op_i:
 if (cmps(opcode,"in.b"))       goto _inb;
 if (cmps(opcode,"in.l"))       goto _inl;
 if (cmps(opcode,"in.w"))       goto _inw;
 if (cmps(opcode,"inc.b"))      goto _incb;
 if (cmps(opcode,"inc.l"))      goto _incl;
 if (cmps(opcode,"inc.w"))      goto _incw;
 if (cmps(opcode,"invl_cache")) goto _invlcache;
 if (cmps(opcode,"invl_cache_wb")) goto _invlwb;
 if (cmps(opcode,"invl_tlb"))   goto _invltbl;
 ende(153,1);

op_j:
 if (cmps(opcode,"jmp.l"))      goto _jmpl;
 if (cmps(opcode,"jmp.w"))      goto _jmpw;
 if (cmps(opcode,"jmp.ww"))     goto _jmpww;
 if (cmps(opcode,"jmp.wl"))     goto _jmpwl;
 if (cmps(opcode,"jsr.l"))      goto _jsrl;
 if (cmps(opcode,"jsr.w"))      goto _jsrw;
 if (cmps(opcode,"jsr.wl"))     goto _jsrwl;
 if (cmps(opcode,"jsr.ww"))     goto _jsrww;
 ende(154,1);

op_k:
 ende(155,1);

op_l:
 if (cmps(opcode,"label_block")) goto _label;
 if (cmps(opcode,"link.l"))     goto _linkl;
 if (cmps(opcode,"link.w"))     goto _linkw;
 if (cmps(opcode,"lar.l"))      goto _larl;
 if (cmps(opcode,"lar.w"))      goto _larw;
 if (cmps(opcode,"ldsl.l"))     goto _ldsll;
 if (cmps(opcode,"ldsl.w"))     goto _ldslw;
 if (cmps(opcode,"lea.l"))      goto _leal;
 if (cmps(opcode,"lea.w"))      goto _leaw;
 if (cmps(opcode,"list"))       goto _list;
 if (cmps(opcode,"lsl.b"))      goto _lslb;
 if (cmps(opcode,"lsl.l"))      goto _lsll;
 if (cmps(opcode,"lsl.w"))      goto _lslw;
 if (cmps(opcode,"lsr.b"))      goto _lsrb;
 if (cmps(opcode,"lsr.l"))      goto _lsrl;
 if (cmps(opcode,"lsr.w"))      goto _lsrw;
 ende(156,1);

op_m:
 if (cmps(opcode,"move.b"))     goto _moveb;
 if (cmps(opcode,"move.l"))     goto _movel;
 if (cmps(opcode,"move.w"))     goto _movew;
 if (cmps(opcode,"movem.l"))    goto _moveml;
 if (cmps(opcode,"movem.w"))    goto _movemw;
 if (cmps(opcode,"moveq.l"))    goto _moveql;
 if (cmps(opcode,"moveq.w"))    goto _moveqw;
 if (cmps(opcode,"movs.bl"))    goto _movsbl;
 if (cmps(opcode,"movs.bw"))    goto _movsbw;
 if (cmps(opcode,"movs.wl"))    goto _movswl;
 if (cmps(opcode,"movu.bl"))    goto _movubl;
 if (cmps(opcode,"movu.bw"))    goto _movubw;
 if (cmps(opcode,"movu.wl"))    goto _movuwl;
 if (cmps(opcode,"muls.b"))     goto _mulsb;
 if (cmps(opcode,"muls.l"))     goto _mulsl;
 if (cmps(opcode,"muls.w"))     goto _mulsw;
 if (cmps(opcode,"mulsq.l"))    goto _mulsql;
 if (cmps(opcode,"mulsq.w"))    goto _mulsqw;
 if (cmps(opcode,"mulu.b"))     goto _mulub;
 if (cmps(opcode,"mulu.l"))     goto _mulul;
 if (cmps(opcode,"mulu.w"))     goto _muluw;
 ende(157,1);

op_n:
 if (cmps(opcode,"neg.b"))      goto _negb;
 if (cmps(opcode,"neg.l"))      goto _negl;
 if (cmps(opcode,"neg.w"))      goto _negw;
 if (cmps(opcode,"nolist"))     goto _nolist;
 if (cmps(opcode,"nop"))        goto _nop;
 if (cmps(opcode,"not.b"))      goto _notb;
 if (cmps(opcode,"not.l"))      goto _notl;
 if (cmps(opcode,"not.w"))      goto _notw;
 ende(158,1);

op_o:
 if (cmps(opcode,"odd"))        goto _odd;
 if (cmps(opcode,"or.b"))       goto _orb;
 if (cmps(opcode,"or.l"))       goto _orl;
 if (cmps(opcode,"or.w"))       goto _orw;
 if (cmps(opcode,"orq.l"))      goto _orql;
 if (cmps(opcode,"orq.w"))      goto _orqw;
 if (cmps(opcode,"out.b"))      goto _outb;
 if (cmps(opcode,"out.l"))      goto _outl;
 if (cmps(opcode,"out.w"))      goto _outw;
 ende(159,1);

op_p:
 if (cmps(opcode,"prefetch.b")) goto _prefetchb;
 ende(160,1);

op_q:
 ende(161,1);

op_r:
 if (cmps(opcode,"rocl.b"))     goto _roclb;
 if (cmps(opcode,"rocl.l"))     goto _rocll;
 if (cmps(opcode,"rocl.w"))     goto _roclw;
 if (cmps(opcode,"rocr.b"))     goto _rocrb;
 if (cmps(opcode,"rocr.l"))     goto _rocrl;
 if (cmps(opcode,"rocr.w"))     goto _rocrw;
 if (cmps(opcode,"rol.b"))      goto _rolb;
 if (cmps(opcode,"rol.l"))      goto _roll;
 if (cmps(opcode,"rol.w"))      goto _rolw;
 if (cmps(opcode,"ror.b"))      goto _rorb;
 if (cmps(opcode,"ror.l"))      goto _rorl;
 if (cmps(opcode,"ror.w"))      goto _rorw;
 if (cmps(opcode,"rte.l"))      goto _rtel;
 if (cmps(opcode,"rte.w"))      goto _rtew;
 if (cmps(opcode,"rts.l"))      goto _rtsl;
 if (cmps(opcode,"rts.ll"))     goto _rtsll;
 if (cmps(opcode,"rts.w"))      goto _rtsw;
 if (cmps(opcode,"rts.ww"))     goto _rtsww;
 ende(162,1);

op_s:
 if (cmps(opcode,"scc.b"))      goto _sccb;
 if (cmps(opcode,"scs.b"))      goto _scsb;
 if (cmps(opcode,"seg16"))      goto _seg16;
 if (cmps(opcode,"seg32"))      goto _seg32;
 if (cmps(opcode,"seq.b"))      goto _seqb;
 if (cmps(opcode,"sge.b"))      goto _sgeb;
 if (cmps(opcode,"sgt.b"))      goto _sgtb;
 if (cmps(opcode,"shi.b"))      goto _shib;
 if (cmps(opcode,"shs.b"))      goto _shsb;
 if (cmps(opcode,"sle.b"))      goto _sleb;
 if (cmps(opcode,"slo.b"))      goto _slob;
 if (cmps(opcode,"sls.b"))      goto _slsb;
 if (cmps(opcode,"slt.b"))      goto _sltb;
 if (cmps(opcode,"smi.b"))      goto _smib;
 if (cmps(opcode,"sne.b"))      goto _sneb;
 if (cmps(opcode,"spc.b"))      goto _spcb;
 if (cmps(opcode,"spl.b"))      goto _splb;
 if (cmps(opcode,"sps.b"))      goto _spsb;
 if (cmps(opcode,"subc.b"))     goto _subcb;
 if (cmps(opcode,"subc.l"))     goto _subcl;
 if (cmps(opcode,"subc.w"))     goto _subcw;
 if (cmps(opcode,"subcq.l"))    goto _subcql;
 if (cmps(opcode,"subcq.w"))    goto _subcqw;
 if (cmps(opcode,"svc.b"))      goto _svcb;
 if (cmps(opcode,"svs.b"))      goto _svsb;
 if (cmps(opcode,"sub.b"))      goto _subb;
 if (cmps(opcode,"sub.l"))      goto _subl;
 if (cmps(opcode,"sub.w"))      goto _subw;
 if (cmps(opcode,"subq.l"))     goto _subql;
 if (cmps(opcode,"subq.w"))     goto _subqw;
 ende(163,1);

op_t:
 if (cmps(opcode,"trap"))       goto _trap;
 if (cmps(opcode,"trapv"))      goto _trapv;
 if (cmps(opcode,"tst.b"))      goto _tstb;
 if (cmps(opcode,"tst.l"))      goto _tstl;
 if (cmps(opcode,"tst.w"))      goto _tstw;
 ende(164,1);

op_u:
 if (cmps(opcode,"unlk.l"))     goto _unlkl;
 if (cmps(opcode,"unlk.w"))     goto _unlkw;
 ende(165,1);

op_v:
 if (cmps(opcode,"verr.w"))     goto _verrw;
 if (cmps(opcode,"verw.w"))     goto _verww;
 ende(166,1);

op_w:
 if (cmps(opcode,"wait"))       goto _wait;
 ende(167,1);

op_x:
 if (cmps(opcode,"xadd.b"))     goto _xaddb;
 if (cmps(opcode,"xadd.l"))     goto _xaddl;
 if (cmps(opcode,"xadd.w"))     goto _xaddw;
 ende(168,1);

op_y:
 ende(169,1);

op_z:
 ende(170,1);


/*************************************************************/
/*************************************************************/
_label:
 if (!pass2)
     {++lab_last;
      if (lab_last > maxlabel) ende(345,24);
      lab_block=lab_last+1;
      lab_pa[lab_block]=lab_pa[lab_last];
      lab_guelt[lab_block]=0;
     }
     else
     {lab_block=lab_lokal;
      while (lab_guelt[lab_block++]);
     }
 goto nextline;



/*************************************************************/
_lslb:
 goto _aslb;
/*************************************************************/
_lsll:
 goto _asll;

/*************************************************************/
_lslw:
 goto _aslw;

/*************************************************************/
_lsrb:
 get_operand(operand);
 dec_operand(operand,&op1); 
 if (cmps(operand,"#1")) i=1; else i=0;
 get_operand(operand);
 dec_boperand(operand,&op2); 

 if ( i && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0xd0);
    mod__sib(5,&op2);
    goto nextline;
   }
 
 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (op1.reg1 != 1) ende(171,4);
    adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0xc0);
    mod__sib(5,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op1.reg1==2 && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0xd2);
    mod__sib(5,&op2);
    goto nextline;
   }

 ende(172,3);

/*************************************************************/
_lsrl:
 op32=1;
/*-----------------------------------------------------------*/
_lsrw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 if (cmps(operand,"#1")) i=1; else i=0;
 get_operand(operand);
 dec_operand(operand,&op2); 

 if ( i && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0xd1);
    mod__sib(5,&op2);
    goto nextline;
   }
 
 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (op1.reg1 != 1) ende(173,4);
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0xc1);
    mod__sib(5,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op1.reg1==2 && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0xd3);
    mod__sib(5,&op2);
    goto nextline;
   }

 ende(174,3);

/*************************************************************/
_moveb:
 get_operand(operand);
 dec_boperand(operand,&op1); 
 get_operand(operand);
 dec_boperand(operand,&op2); 

 if (op1.nr == 34  && op2.nr == 3 )
   {if (op1.reg1 != 1) ende(175,4);
    aus_byte(0xb0 + trans(op2.reg1) );
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (op1.reg1 != 1) ende(176,4);
    adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0xc6);
    mod__sib(0,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op1.reg1 == 0 && (op2.nr == 4 || op2.nr == 11 ))
   {adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0xa2);

    if (op2.nr == 4) 
       {if (op2.konst > high16 || op2.konst < low16) ende(177,5);
        aus_word( (int) op2.konst);
       }
       else aus_long(op2.konst);

    goto nextline;
   }

 if ( op2.nr == 3 && op2.reg1 == 0 && (op1.nr == 4 || op1.nr == 11 ))
   {adr_pre(&op1);
    seg_pre(&op1);
    aus_byte(0xa0);

    if (op1.nr == 4) 
       {if (op1.konst > high16 || op1.konst < low16) ende(178,5);
        aus_word( (int) op1.konst);
       }
       else aus_long(op1.konst);

    goto nextline;
   }



 if ( op1.nr == 3 && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0x88);
    mod_sib(op1.reg1,&op2);
    goto nextline;
   }

 if ( op2.nr == 3 && op1.nr >= 3  && op1.nr <= 30)
   {adr_pre(&op1);
    seg_pre(&op1);
    aus_byte(0x8a);
    mod_sib(op2.reg1,&op1);
    goto nextline;
   }

 if ( (op1.nr == 45 || op1.nr == 46) && op2.nr == 3 && op2.reg1 == 0 )
   {if (op_pref == 1) {aus_byte(0xf2); op_pref=0;}
    adr_pre(&op1);
    seg_pre(&op1);
    aus_byte(0xac);
    goto nextline;
   }

 if ( (op2.nr == 43 || op2.nr == 44) && op1.nr == 3 && op1.reg1 == 0 )
   {if (op_pref == 1) {aus_byte(0xf3); op_pref=0;}
    adr_pre(&op2);
    aus_byte(0xaa);
    goto nextline;
   }


 if ( op1.nr == 45 && op2.nr == 43 || op1.nr == 46 && op2.nr == 44 )
   {if (op_pref == 1) {aus_byte(0xf3); op_pref=0;}
    adr_pre(&op1);
    seg_pre(&op1);
    aus_byte(0xa4);
    goto nextline;
   }


 if ( (op1.nr == 50 || op1.nr == 51) && op2.nr == 3 && op2.reg1 == 0 )
   {if (op_pref == 1) {aus_byte(0xf2); op_pref=0;}
    adr_pre(&op1);
    seg_pre(&op1);
    aus_byte(0xd7);
    goto nextline;
   }


 if ( op1.nr == 35 && op2.nr == 3  && op2.reg1 == 7)
   {aus_byte(0x9f);
    goto nextline;
   }

 if ( op2.nr == 35 && op1.nr == 3  && op1.reg1 == 7)
   {aus_byte(0x9e);
    goto nextline;
   }

 ende(179,3);

/*************************************************************/
_movel:
 op32=1;
/*-----------------------------------------------------------*/
_movew:
 get_operand(operand);

 if (cmps(operand,"timestampcounter")&&op32) 
    {get_operand(operand); 
     if (cmps(operand,"r1|r0")) {aus_byte(0x0f); aus_byte(0x31);} 
         else ende(348,16);
     goto nextline;}
     
 if (cmps(operand,"cpuid")&&op32) 
    {get_operand(operand); 
     if (cmps(operand,"r3|r2|r1|r0")) {aus_byte(0x0f); aus_byte(0xa2);} 
         else ende(348,16);
     goto nextline;}
     
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 


 if (op1.nr == 34  && op2.nr == 3 )
   {if (!op32 && op1.reg1 > 2) ende(180,5);
    if (seg32 ^ op32) aus_byte(0x66);
    aus_byte(0xb8 + trans(op2.reg1) );
    if (! op32) aus_word((int)op1.konst); else aus_long(op1.konst);
    goto nextline;
   }

 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (!op32 && op1.reg1 > 2) ende(181,5);
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0xc7);
    mod__sib(0,&op2);
    if (! op32) aus_word((int)op1.konst); else aus_long(op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op1.reg1 == 0 && (op2.nr == 4 || op2.nr == 11 ))
   {adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0xa3);

    if (op2.nr == 4) 
       {if (op2.konst > high16 || op2.konst < low16) ende(182,5);
        aus_word( (int) op2.konst);
       }
       else aus_long(op2.konst);

    goto nextline;
   }

 if ( op2.nr == 3 && op2.reg1 == 0 && (op1.nr == 4 || op1.nr == 11 ))
   {adr_pre(&op1);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op1);
    aus_byte(0xa1);

    if (op1.nr == 4) 
       {if (op1.konst > high16 || op1.konst < low16) ende(183,5);
        aus_word( (int) op1.konst);
       }
       else aus_long(op1.konst);

    goto nextline;
   }



 if ( op1.nr == 3 && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x89);
    mod_sib(op1.reg1,&op2);
    goto nextline;
   }

 if ( op2.nr == 3 && op1.nr >= 3  && op1.nr <= 30)
   {adr_pre(&op1);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op1);
    aus_byte(0x8b);
    mod_sib(op2.reg1,&op1);
    goto nextline;
   }


 if ( (op1.nr == 45 || op1.nr == 46) && op2.nr == 3 && op2.reg1 == 0 )
   {if (op_pref == 1) {aus_byte(0xf2); op_pref=0;}
    adr_pre(&op1);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op1);
    aus_byte(0xad);
    goto nextline;
   }

 if ( (op2.nr == 43 || op2.nr == 44) && op1.nr == 3 && op1.reg1 == 0 )
   {if (op_pref == 1) {aus_byte(0xf3); op_pref=0;}
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    aus_byte(0xab);
    goto nextline;
   }


 if ( op1.nr == 45 && op2.nr == 43 || op1.nr == 46 && op2.nr == 44 )
   {if (op_pref == 1) {aus_byte(0xf3); op_pref=0;}
    adr_pre(&op1);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op1);
    aus_byte(0xa5);
    goto nextline;
   }


 if ( (op1.nr == 40 || op1.nr == 41) && op2.nr >= 4 && op2.nr <= 30 )
   {adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x0f);
    aus_byte(0x01);
    if (op1.nr == 40) mod__sib(0,&op2); else mod__sib(1,&op2);
    goto nextline;
   }

 if ( (op2.nr == 40 || op2.nr == 41)  && op1.nr >= 4  && op1.nr <= 30)
   {adr_pre(&op1);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op1);
    aus_byte(0x0f);
    aus_byte(0x01);
    if (op2.nr == 40) mod__sib(2,&op1); else mod__sib(3,&op1);
    goto nextline;
   }

 if ( op2.nr == 49 && op1.nr >= 4  && op1.nr <= 30)
   {adr_pre(&op1);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op1);

    switch(op2.segm)
     {
      case 0: {aus_byte(0xc5); break;}
      case 1: {aus_byte(0xc4); break;}
      case 2: {aus_byte(0x0f); aus_byte(0xb4); break;}
      case 3: {aus_byte(0x0f); aus_byte(0xb5); break;}
      case 7: {aus_byte(0x0f); aus_byte(0xb2); break;}
      default:  ende(184,3);
     }
    mod_sib(op2.reg1,&op1);
    goto nextline;
   }


 if ( op1.nr == 31 && op2.nr == 3 )
   {adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x58+trans(op2.reg1));
    goto nextline;
   }

 if ( op2.nr == 32 && op1.nr == 3 )
   {adr_pre(&op1);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op1);
    aus_byte(0x50+trans(op1.reg1));
    goto nextline;
   }


 if ( op1.nr == 31 && op2.nr >= 4 && op2.nr <= 30 )
   {adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x8f);
    mod__sib(0,&op2);
    goto nextline;
   }

 if ( op2.nr == 32 && op1.nr >= 4  && op1.nr <= 30)
   {adr_pre(&op1);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op1);
    aus_byte(0xff);
    mod__sib(6,&op1);
    goto nextline;
   }

 if ( op1.nr == 31 && op2.nr == 35 )
   {if (seg32 ^ op32) aus_byte(0x66);
    aus_byte(0x9d);
    goto nextline;
   }

 if ( op2.nr == 32 && op1.nr == 35 )
   {if (seg32 ^ op32) aus_byte(0x66);
    aus_byte(0x9c);
    goto nextline;
   }

 if (op1.nr == 34  && op2.nr == 32 )
   {if (!op32 && op1.reg1 > 2) ende(185,5);
    if (seg32 ^ op32) aus_byte(0x66);
    aus_byte(0x68);
    if (! op32) aus_word((int)op1.konst); else aus_long(op1.konst);
    goto nextline;
   }

 if (op1.nr==52 && op2.nr==32)
   {if (seg32 ^ op32) aus_byte(0x66);
    switch(op1.segm)
     {case 0: {aus_byte(0x1e); break;}
      case 1: {aus_byte(0x06); break;}
      case 2: {aus_byte(0x0f); aus_byte(0xa0); break;}
      case 3: {aus_byte(0x0f); aus_byte(0xa8); break;}
      case 6: {aus_byte(0x0e); break;}
      case 7: {aus_byte(0x16); break;}
      default:  ende(186,3);
     }
    goto nextline;
   }

 if (op2.nr==52 && op1.nr==31)
   {if (seg32 ^ op32) aus_byte(0x66);
    switch(op2.segm)
     {case 0: {aus_byte(0x1f); break;}
      case 1: {aus_byte(0x07); break;}
      case 2: {aus_byte(0x0f); aus_byte(0xa1); break;}
      case 3: {aus_byte(0x0f); aus_byte(0xa9); break;}
      case 7: {aus_byte(0x17); break;}
      default:  ende(187,3);
     }
    goto nextline;
   }

 if (op1.nr==52 && op1.segm!=4 && op1.segm!=5 && op2.nr>=3 && op2.nr<=30)
   {adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x8c);
    mod_sib(op1.reg1,&op2);
    goto nextline;
   }

 if (op2.nr==52 && op2.segm!=4 && op2.segm!=5 && op2.segm!=6 &&
     op1.nr>=3 && op1.nr<=30)
   {adr_pre(&op1);
    seg_pre(&op1);
    aus_byte(0x8e);
    mod_sib(op2.reg1,&op1);
    goto nextline;
   }

 if (op32)
    {if (op1.nr == 3  && op2.nr == 36 
                      && (op2.reg1==0 || op2.reg1==2 || op2.reg1==3))
        {aus_byte(0x0f);
         aus_byte(0x22);
         mod__sib(op2.reg1,&op1);
         goto nextline;
        }

     if (op2.nr == 3  && op1.nr == 36 
                      && (op1.reg1==0 || op1.reg1==2 || op1.reg1==3))
        {aus_byte(0x0f);
         aus_byte(0x20);
         mod__sib(op1.reg1,&op2);
         goto nextline;
        }

     if (op1.nr == 3  && op2.nr == 37  && op2.reg1 != 4 && op2.reg1 != 5)
        {aus_byte(0x0f);
         aus_byte(0x23);
         mod__sib(op2.reg1,&op1);
         goto nextline;
        }

     if (op2.nr == 3  && op1.nr == 37  && op1.reg1 != 4 && op1.reg1 != 5)
        {aus_byte(0x0f);
         aus_byte(0x21);
         mod__sib(op1.reg1,&op2);
         goto nextline;
        }

     if (op1.nr == 3  && op2.nr == 38  && op2.reg1 >= 3)
        {aus_byte(0x0f);
         aus_byte(0x26);
         mod__sib(op2.reg1,&op1);
         goto nextline;
        }

     if (op2.nr == 3  && op1.nr == 38  && op1.reg1 >= 3)
        {aus_byte(0x0f);
         aus_byte(0x24);
         mod__sib(op1.reg1,&op2);
         goto nextline;
        }
    }
    else
    {

     if ( op1.nr == 39 && op2.nr >= 3 && op2.nr <= 30 )
       {adr_pre(&op2);
        seg_pre(&op2);
        aus_byte(0x0f);
        aus_byte(0x00);
        mod__sib(0,&op2);
        goto nextline;
       }

     if ( op2.nr == 39 && op1.nr >= 3  && op1.nr <= 30)
       {adr_pre(&op1);
        seg_pre(&op1);
        aus_byte(0x0f);
        aus_byte(0x00);
        mod__sib(2,&op1);
        goto nextline;
       }

     if ( op1.nr==36 && op1.reg1==0 && op2.nr >= 3 && op2.nr <= 30 )
       {adr_pre(&op2);
        seg_pre(&op2);
        aus_byte(0x0f);
        aus_byte(0x01);
        mod__sib(4,&op2);
        goto nextline;
       }

     if ( op2.nr==36 && op2.reg1==0 && op1.nr >= 3  && op1.nr <= 30)
       {adr_pre(&op1);
        seg_pre(&op1);
        aus_byte(0x0f);
        aus_byte(0x01);
        mod__sib(6,&op1);
        goto nextline;
       }

     if ( op1.nr == 42 && op2.nr >= 3 && op2.nr <= 30 )
       {adr_pre(&op2);
        seg_pre(&op2);
        aus_byte(0x0f);
        aus_byte(0x00);
        mod__sib(1,&op2);
        goto nextline;
       }

     if ( op2.nr == 42 && op1.nr >= 3  && op1.nr <= 30)
       {adr_pre(&op1);
        seg_pre(&op1);
        aus_byte(0x0f);
        aus_byte(0x00);
        mod__sib(3,&op1);
        goto nextline;
       }


    }

 ende(188,3);

/*************************************************************/
_moveml:
 op32=1;
/*-----------------------------------------------------------*/
_movemw:

 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (seg32 ^ op32) aus_byte(0x66);
 if (op1.nr == 31 && op2.nr == 33) 
    {aus_byte(0x61);
#if popad_bug==1 
     if (op32) aus_byte(0x90);
#endif      
     goto nextline;}
 if (op1.nr == 33 && op2.nr == 32) {aus_byte(0x60); goto nextline;}
 ende(189,3);


/*************************************************************/
_moveql:
 op32=1;
/*-----------------------------------------------------------*/
_moveqw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr == 34  && op2.nr == 32)
   {if (op1.reg1 != 1) ende(190,4);
    if (seg32 ^ op32) aus_byte(0x66);
    aus_byte(0x6a);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 ende(191,3);


/*************************************************************/
_movsbl:
 op32=1;
/*-----------------------------------------------------------*/
_movsbw:
 get_operand(operand);
 dec_boperand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if ( op2.nr == 3 && op1.nr >= 3 && op1.nr <= 30 )
   {adr_pre(&op1);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op1);
    aus_byte(0x0f);
    aus_byte(0xbe);
    mod_sib(op2.reg1,&op1);
    goto nextline;
   }

 ende(192,3);

/*************************************************************/
_movswl:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if ( op2.nr == 3 && op1.nr >= 3 && op1.nr <= 30 )
   {adr_pre(&op1);
    if (!seg32) aus_byte(0x66);  /* als 16-Bit Befehl gleich move.w */
    seg_pre(&op1);
    aus_byte(0x0f);
    aus_byte(0xbf);
    mod_sib(op2.reg1,&op1);
    goto nextline;
   }

 ende(193,3);


/*************************************************************/
_movubl:
 op32=1;
/*-----------------------------------------------------------*/
_movubw:
 get_operand(operand);
 dec_boperand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if ( op2.nr == 3 && op1.nr >= 3 && op1.nr <= 30 )
   {adr_pre(&op1);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op1);
    aus_byte(0x0f);
    aus_byte(0xb6);
    mod_sib(op2.reg1,&op1);
    goto nextline;
   }

 ende(194,3);

/*************************************************************/
_movuwl:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if ( op2.nr == 3 && op1.nr >= 3 && op1.nr <= 30 )
   {adr_pre(&op1);
    if (!seg32) aus_byte(0x66);  /* als 16-Bit Befehl gleich move.w */
    seg_pre(&op1);
    aus_byte(0x0f);
    aus_byte(0xb7);
    mod_sib(op2.reg1,&op1);
    goto nextline;
   }

 ende(195,3);


/*************************************************************/
_mulsb:
 get_operand(operand);
 dec_boperand(operand,&op1); 
 get_operand(operand);
 dec_boperand(operand,&op2); 
 get_operand(operand);
 dec_operand(operand,&op3); 

 if ( op1.nr >= 3 && op1.nr <= 30 && op2.nr == 3 && op2.reg1 == 0 
      && op3.nr == 48 )
   {adr_pre(&op1);
    seg_pre(&op1);
    aus_byte(0xf6);
    mod__sib(5,&op1);
    goto nextline;
   }

 ende(196,3);

/*************************************************************/
_mulsl:
 op32=1;
/*-----------------------------------------------------------*/
_mulsw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 
 get_operand(operand);
 dec_operand(operand,&op3); 

 if ( op1.nr >= 3 && op1.nr <= 30 && op2.nr == 3 && op2.reg1 == 0 
      && op3.nr == 47 )
   {adr_pre(&op1);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op1);
    aus_byte(0xf7);
    mod__sib(5,&op1);
    goto nextline;
   }

 if ( op1.nr >= 3 && op1.nr <= 30 && op2.nr == 3 
      && op3.nr == 3 && op2.reg1 == op3.reg1 )
   {adr_pre(&op1);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op1);
    aus_byte(0x0f);
    aus_byte(0xaf);
    mod_sib(op2.reg1,&op1);
    goto nextline;
   }

 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30 && op3.nr == 3)
   {if (!op32 && op1.reg1 > 2) ende(197,5);
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x69);
    mod_sib(op3.reg1,&op2);
    if (! op32) aus_word((int)op1.konst); else aus_long(op1.konst);
    goto nextline;
   }

 ende(198,3);


/*************************************************************/
_mulsql:
 op32=1;
/*-----------------------------------------------------------*/
_mulsqw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 
 get_operand(operand);
 dec_operand(operand,&op3); 

 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30 && op3.nr == 3)
   {if  (op1.reg1 != 1) ende(199,4);
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x6b);
    mod_sib(op3.reg1,&op2);
    aus_byte((int)op1.konst); 
    goto nextline;
   }

 ende(200,3);



/*************************************************************/
_mulub:
 get_operand(operand);
 dec_boperand(operand,&op1); 
 get_operand(operand);
 dec_boperand(operand,&op2); 
 get_operand(operand);
 dec_operand(operand,&op3); 

 if ( op1.nr >= 3 && op1.nr <= 30 && op2.nr == 3 && op2.reg1 == 0 
      && op3.nr == 48 )
   {adr_pre(&op1);
    seg_pre(&op1);
    aus_byte(0xf6);
    mod__sib(4,&op1);
    goto nextline;
   }

 ende(201,3);

/*************************************************************/
_mulul:
 op32=1;
/*-----------------------------------------------------------*/
_muluw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 
 get_operand(operand);
 dec_operand(operand,&op3); 

 if ( op1.nr >= 3 && op1.nr <= 30 && op2.nr == 3 && op2.reg1 == 0 
      && op3.nr == 47 )
   {adr_pre(&op1);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op1);
    aus_byte(0xf7);
    mod__sib(4,&op1);
    goto nextline;
   }

 ende(202,3);

/*************************************************************/
_negb:
 get_operand(operand);
 dec_boperand(operand,&op1); 

 if ( op1.nr >= 3 && op1.nr <= 30 )
   {if (op1.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op1);
    seg_pre(&op1);
    aus_byte(0xf6);
    mod__sib(3,&op1);
    goto nextline;
   }

 ende(203,3);

/*************************************************************/
_negl:
 op32=1;
/*-----------------------------------------------------------*/
_negw:
 get_operand(operand);
 dec_operand(operand,&op1); 

 if ( op1.nr >= 3 && op1.nr <= 30 )
   {if (op1.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op1);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op1);
    aus_byte(0xf7);
    mod__sib(3,&op1);
    goto nextline;
   }

 ende(204,3);

/*************************************************************/
_nolist:
 list_level--;
 goto nextline;

/*************************************************************/
_nop:
 aus_byte(0x90);
 goto nextline;

/*************************************************************/
_notb:
 get_operand(operand);
 dec_boperand(operand,&op1); 

 if ( op1.nr >= 3 && op1.nr <= 30 )
   {if (op1.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op1);
    seg_pre(&op1);
    aus_byte(0xf6);
    mod__sib(2,&op1);
    goto nextline;
   }

 ende(205,3);

/*************************************************************/
_notl:
 op32=1;
/*-----------------------------------------------------------*/
_notw:
 get_operand(operand);
 dec_operand(operand,&op1); 

 if ( op1.nr >= 3 && op1.nr <= 30 )
   {if (op1.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op1);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op1);
    aus_byte(0xf7);
    mod__sib(2,&op1);
    goto nextline;
   }

 ende(206,3);

/*************************************************************/
_odd:
 if (!( *lab_wert & (long) 1) ) aus_byte(0x00);
 goto nextline;

/*************************************************************/
_orb:
 get_operand(operand);
 dec_boperand(operand,&op1); 
 get_operand(operand);
 dec_boperand(operand,&op2); 

 if (op1.nr == 34  && op2.nr == 3 && op2.reg1 == 0)
   {if (op1.reg1 != 1) ende(207,4);
    aus_byte(0x0c);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (op1.reg1 != 1) ende(208,4);
    if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0x80);
    mod__sib(1,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op2.nr >= 3 && op2.nr <= 30 )
   {if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0x08);
    mod_sib(op1.reg1,&op2);
    goto nextline;
   }

 if ( op2.nr == 3 && op1.nr >= 3  && op1.nr <= 30)
   {
    adr_pre(&op1);
    seg_pre(&op1);
    aus_byte(0x0a);
    mod_sib(op2.reg1,&op1);
    goto nextline;
   }

 ende(209,3);

/*************************************************************/
_orl:
 op32=1;
/*-----------------------------------------------------------*/
_orw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr == 34  && op2.nr == 3 && op2.reg1 == 0)
   {if (!op32 && op1.reg1 > 2) ende(210,5);
    if (seg32 ^ op32) aus_byte(0x66);
    aus_byte(0x0d);
    if (! op32) aus_word((int)op1.konst); else aus_long(op1.konst);
    goto nextline;
   }

 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (!op32 && op1.reg1 > 2) ende(211,5);
    if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x81);
    mod__sib(1,&op2);
    if (! op32) aus_word((int)op1.konst); else aus_long(op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op2.nr >= 3 && op2.nr <= 30 )
   {if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x09);
    mod_sib(op1.reg1,&op2);
    goto nextline;
   }

 if ( op2.nr == 3 && op1.nr >= 3  && op1.nr <= 30)
   {adr_pre(&op1);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op1);
    aus_byte(0x0b);
    mod_sib(op2.reg1,&op1);
    goto nextline;
   }

 ende(212,3);

/*************************************************************/
_orql:
 op32=1;
/*-----------------------------------------------------------*/
_orqw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (op1.reg1 != 1) ende(213,4);
    if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x83);
    mod__sib(1,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 ende(214,3);

/*************************************************************/
_outb:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op2.nr == 34  && op1.nr == 3 && op1.reg1 == 0)
   {if (op2.reg1 != 1) ende(215,4);
    aus_byte(0xe6);
    aus_byte((int)op2.konst);
    goto nextline;
   }

 if (op2.nr == 3 && op2.reg1 == 1  && op1.nr == 3 && op1.reg1 == 0)
   {aus_byte(0xee);
    goto nextline;
   }

 if ( op2.nr == 3 && op2.reg1 == 1 && (op1.nr == 45 || op2.nr == 46) )
   {if      (op_pref == 1) {aus_byte(0xf3); op_pref=0;}
    adr_pre(&op1);
    aus_byte(0x6e);
    goto nextline;
   }
 ende(216,3);


/*************************************************************/
_outl:
 op32=1;
/*-----------------------------------------------------------*/
_outw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op2.nr == 34  && op1.nr == 3 && op1.reg1 == 0)
   {if (op2.reg1 != 1) ende(217,4);
    if (seg32 ^ op32) aus_byte(0x66);
    aus_byte(0xe7);
    aus_byte((int)op2.konst);
    goto nextline;
   }

 if (op2.nr == 3 && op2.reg1 == 1  && op1.nr == 3 && op1.reg1 == 0)
   {if (seg32 ^ op32) aus_byte(0x66);
    aus_byte(0xef);
    goto nextline;
   }

 if ( op2.nr == 3 && op2.reg1 == 1 && (op1.nr == 45 || op1.nr == 46) )
   {if      (op_pref == 1) {aus_byte(0xf3); op_pref=0;}
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    aus_byte(0x6f);
    goto nextline;
   }
 ende(218,3);

/*-----------------------------------------------------------*/
_prefetchb:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if ( op1.nr == 34 && op1.konst <=3 && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0x0f);
    aus_byte(0x18);
    mod__sib(op1.konst,&op2);
    goto nextline;
   }

 ende(2180,3);

/*************************************************************/


/*************************************************************/
_roclb:
 get_operand(operand);
 dec_operand(operand,&op1); 
 if (cmps(operand,"#1")) i=1; else i=0;
 get_operand(operand);
 dec_boperand(operand,&op2); 

 if ( i && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0xd0);
    mod__sib(2,&op2);
    goto nextline;
   }
 
 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (op1.reg1 != 1) ende(219,4);
    adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0xc0);
    mod__sib(2,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op1.reg1==2 && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0xd2);
    mod__sib(2,&op2);
    goto nextline;
   }

 ende(220,3);

/*************************************************************/
_rocll:
 op32=1;
/*-----------------------------------------------------------*/
_roclw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 if (cmps(operand,"#1")) i=1; else i=0;
 get_operand(operand);
 dec_operand(operand,&op2); 

 if ( i && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0xd1);
    mod__sib(2,&op2);
    goto nextline;
   }
 
 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (op1.reg1 != 1) ende(221,4);
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0xc1);
    mod__sib(2,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op1.reg1==2 && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0xd3);
    mod__sib(2,&op2);
    goto nextline;
   }

 ende(222,3);

/*************************************************************/
_rocrb:
 get_operand(operand);
 dec_operand(operand,&op1); 
 if (cmps(operand,"#1")) i=1; else i=0;
 get_operand(operand);
 dec_boperand(operand,&op2); 

 if ( i && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0xd0);
    mod__sib(3,&op2);
    goto nextline;
   }
 
 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (op1.reg1 != 1) ende(223,4);
    adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0xc0);
    mod__sib(3,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op1.reg1==2 && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0xd2);
    mod__sib(3,&op2);
    goto nextline;
   }

 ende(224,3);

/*************************************************************/
_rocrl:
 op32=1;
/*-----------------------------------------------------------*/
_rocrw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 if (cmps(operand,"#1")) i=1; else i=0;
 get_operand(operand);
 dec_operand(operand,&op2); 

 if ( i && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0xd1);
    mod__sib(3,&op2);
    goto nextline;
   }
 
 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (op1.reg1 != 1) ende(225,4);
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0xc1);
    mod__sib(3,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op1.reg1==2 && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0xd3);
    mod__sib(3,&op2);
    goto nextline;
   }

 ende(226,3);



/*************************************************************/
_rolb:
 get_operand(operand);
 dec_operand(operand,&op1); 
 if (cmps(operand,"#1")) i=1; else i=0;
 get_operand(operand);
 dec_boperand(operand,&op2); 

 if ( i && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0xd0);
    mod__sib(0,&op2);
    goto nextline;
   }
 
 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (op1.reg1 != 1) ende(227,4);
    adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0xc0);
    mod__sib(0,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op1.reg1==2 && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0xd2);
    mod__sib(0,&op2);
    goto nextline;
   }

 ende(228,3);

/*************************************************************/
_roll:
 op32=1;
/*-----------------------------------------------------------*/
_rolw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 if (cmps(operand,"#1")) i=1; else i=0;
 get_operand(operand);
 dec_operand(operand,&op2); 

 if ( i && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0xd1);
    mod__sib(0,&op2);
    goto nextline;
   }
 
 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (op1.reg1 != 1) ende(229,4);
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0xc1);
    mod__sib(0,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op1.reg1==2 && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0xd3);
    mod__sib(0,&op2);
    goto nextline;
   }

 ende(230,3);



/*************************************************************/
_rorb:
 get_operand(operand);
 dec_operand(operand,&op1); 
 if (cmps(operand,"#1")) i=1; else i=0;
 get_operand(operand);
 dec_boperand(operand,&op2); 

 if ( i && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0xd0);
    mod__sib(1,&op2);
    goto nextline;
   }
 
 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (op1.reg1 != 1) ende(231,4);
    adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0xc0);
    mod__sib(1,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op1.reg1==2 && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0xd2);
    mod__sib(1,&op2);
    goto nextline;
   }

 ende(232,3);

/*************************************************************/
_rorl:
 op32=1;
/*-----------------------------------------------------------*/
_rorw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 if (cmps(operand,"#1")) i=1; else i=0;
 get_operand(operand);
 dec_operand(operand,&op2); 

 if ( i && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0xd1);
    mod__sib(1,&op2);
    goto nextline;
   }
 
 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (op1.reg1 != 1) ende(233,4);
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0xc1);
    mod__sib(1,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op1.reg1==2 && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0xd3);
    mod__sib(1,&op2);
    goto nextline;
   }

 ende(234,3);



/*************************************************************/
_rtel:
 if (!seg32) aus_byte(0x66);
 aus_byte(0xcf);
 goto nextline;

/*************************************************************/
_rtew:
 if (seg32) aus_byte(0x66);
 aus_byte(0xcf);
 goto nextline;


/*************************************************************/
_rtsl:
 op32=1;
/*-----------------------------------------------------------*/
_rtsw:
 get_operand(operand);
 dec_operand(operand,&op1); 

 if (seg32 ^ op32) aus_byte(0x66);

 if (op1.nr == 1) {aus_byte(0xc3); goto nextline;}

 if (op1.nr == 34)
    {if (op1.reg1 > 2) ende(235,5);
     aus_byte(0xc2);
     aus_word((int)op1.konst);
     goto nextline;
    }

 ende(236,3);

/*************************************************************/
_rtsll:
 op32=1;
/*-----------------------------------------------------------*/
_rtsww:
 get_operand(operand);
 dec_operand(operand,&op1); 

 if (seg32 ^ op32) aus_byte(0x66);

 if (op1.nr == 1) {aus_byte(0xcb); goto nextline;}

 if (op1.nr == 34)
    {if (op1.reg1 > 2) ende(237,5);
     aus_byte(0xca);
     aus_word((int)op1.konst);
     goto nextline;
    }

 ende(238,3);


/*************************************************************/
_set:
 get_operand(operand);
 dec_boperand(operand,&op1); 
 
 if (op1.nr >= 3 && op1.nr <= 30)
   {adr_pre(&op1);
    seg_pre(&op1);
    aus_byte(0x0f);
    aus_byte(i);
    mod__sib(0,&op1);
    goto nextline;
   }
 ende(239,3);

/*************************************************************/
_sccb:
 i=0x93;
 goto _set;

/*************************************************************/
_scsb:
 i=0x92;
 goto _set;

/*************************************************************/
_seg16:
 seg32=0;
 goto nextline;

_seg32:
 seg32=1;
 goto nextline;

/*************************************************************/
_seqb:
 i=0x94;
 goto _set;

/*************************************************************/
_sgeb:
 i=0x9d;
 goto _set;

/*************************************************************/
_sgtb:
 i=0x9f;
 goto _set;

/*************************************************************/
_shib:
 i=0x97;
 goto _set;

/*************************************************************/
_shsb:
 i=0x93;
 goto _set;

/*************************************************************/
_sleb:
 i=0x9e;
 goto _set;

/*************************************************************/
_slob:
 i=0x92;
 goto _set;

/*************************************************************/
_slsb:
 i=0x96;
 goto _set;

/*************************************************************/
_sltb:
 i=0x9c;
 goto _set;

/*************************************************************/
_smib:
 i=0x98;
 goto _set;

/*************************************************************/
_sneb:
 i=0x95;
 goto _set;

/*************************************************************/
_spcb:
 i=0x9b;
 goto _set;

/*************************************************************/
_splb:
 i=0x99;
 goto _set;

/*************************************************************/
_spsb:
 i=0x9a;
 goto _set;

/*************************************************************/
_subcb:
 get_operand(operand);
 dec_boperand(operand,&op1); 
 get_operand(operand);
 dec_boperand(operand,&op2); 

 if (op1.nr == 34  && op2.nr == 3 && op2.reg1 == 0)
   {if (op1.reg1 != 1) ende(240,4);
    aus_byte(0x1c);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (op1.reg1 != 1) ende(241,4);
    if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0x80);
    mod__sib(3,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op2.nr >= 3 && op2.nr <= 30 )
   {if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0x18);
    mod_sib(op1.reg1,&op2);
    goto nextline;
   }

 if ( op2.nr == 3 && op1.nr >= 3  && op1.nr <= 30)
   {adr_pre(&op1);
    seg_pre(&op1);
    aus_byte(0x1a);
    mod_sib(op2.reg1,&op1);
    goto nextline;
   }

ende(242,3);


/*************************************************************/
_subcl:
 op32=1;
/*-----------------------------------------------------------*/

_subcw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr == 34  && op2.nr == 3 && op2.reg1 == 0)
   {if (!op32 && op1.reg1 > 2) ende(243,5);
    if (seg32 ^ op32) aus_byte(0x66);
    aus_byte(0x1d);
    if (! op32) aus_word((int)op1.konst); else aus_long(op1.konst);
    goto nextline;
   }

 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (!op32 && op1.reg1 > 2) ende(244,5);
    if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x81);
    mod__sib(3,&op2);
    if (! op32) aus_word((int)op1.konst); else aus_long(op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op2.nr >= 3 && op2.nr <= 30 )
   {if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x19);
    mod_sib(op1.reg1,&op2);
    goto nextline;
   }

 if ( op2.nr == 3 && op1.nr >= 3  && op1.nr <= 30)
   {adr_pre(&op1);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op1);
    aus_byte(0x1b);
    mod_sib(op2.reg1,&op1);
    goto nextline;
   }

 ende(245,3);

/*************************************************************/
_subcql:
 op32=1;
/*-----------------------------------------------------------*/
_subcqw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (op1.reg1 != 1) ende(246,4);
    if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x83);
    mod__sib(3,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 ende(247,3);


/*************************************************************/
_svcb:
 i=0x91;
 goto _set;

/*************************************************************/
_svsb:
 i=0x90;
 goto _set;

/*************************************************************/
_subb:
 get_operand(operand);
 dec_boperand(operand,&op1); 
 get_operand(operand);
 dec_boperand(operand,&op2); 

 if (op1.nr == 34  && op2.nr == 3 && op2.reg1 == 0)
   {if (op1.reg1 != 1) ende(248,4);
    aus_byte(0x2c);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (op1.reg1 != 1) ende(249,4);
    if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0x80);
    mod__sib(5,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op2.nr >= 3 && op2.nr <= 30 )
   {if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0x28);
    mod_sib(op1.reg1,&op2);
    goto nextline;
   }

 if ( op2.nr == 3 && op1.nr >= 3  && op1.nr <= 30)
   {adr_pre(&op1);
    seg_pre(&op1);
    aus_byte(0x2a);
    mod_sib(op2.reg1,&op1);
    goto nextline;
   }

 ende(250,3);


/*************************************************************/
_subl:
 op32=1;
/*-----------------------------------------------------------*/
_subw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr == 34  && op2.nr == 3 && op2.reg1 == 0)
   {if (!op32 && op1.reg1 > 2) ende(251,5);
    if (seg32 ^ op32) aus_byte(0x66);
    aus_byte(0x2d);
    if (! op32) aus_word((int)op1.konst); else aus_long(op1.konst);
    goto nextline;
   }

 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (!op32 && op1.reg1 > 2) ende(252,5);
    if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x81);
    mod__sib(5,&op2);
    if (! op32) aus_word((int)op1.konst); else aus_long(op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op2.nr >= 3 && op2.nr <= 30 )
   {if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x29);
    mod_sib(op1.reg1,&op2);
    goto nextline;
   }

 if ( op2.nr == 3 && op1.nr >= 3  && op1.nr <= 30)
   {adr_pre(&op1);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op1);
    aus_byte(0x2b);
    mod_sib(op2.reg1,&op1);
    goto nextline;
   }

ende(253,3);

/*************************************************************/
_subql:
 op32=1;
/*-----------------------------------------------------------*/
_subqw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (op1.reg1 != 1) ende(254,4);
    if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x83);
    mod__sib(5,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 ende(255,3);


/*************************************************************/
_trap:
 get_operand(operand);
 dec_operand(operand,&op1); 

 if (op1.nr == 34)
   {if (op1.reg1 != 1) ende(256,4);
    if      ((int)op1.konst == 3) aus_byte(0xcc);
       else {aus_byte(0xcd); aus_byte((int)op1.konst);}
    goto nextline;
   }

 ende(257,3);

/*************************************************************/
_trapv:
 aus_byte(0xce);
 goto nextline;

/*************************************************************/
_tstb:
 get_operand(operand);
 dec_boperand(operand,&op1); 
 get_operand(operand);
 dec_boperand(operand,&op2); 

 if (op1.nr == 34  && op2.nr == 3 && op2.reg1 == 0)
   {if (op1.reg1 != 1) ende(258,4);
    aus_byte(0xa8);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (op1.reg1 != 1) ende(259,4);
    adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0xf6);
    mod__sib(0,&op2);
    aus_byte((int)op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0x84);
    mod_sib(op1.reg1,&op2);
    goto nextline;
   }

 if ( op2.nr == 3 && op1.nr >= 3  && op1.nr <= 30)
   {adr_pre(&op1);
    seg_pre(&op1);
    aus_byte(0x84);
    mod_sib(op2.reg1,&op1);
    goto nextline;
   }

 ende(260,3);


/*************************************************************/
_tstl:
 op32=1;
/*-----------------------------------------------------------*/
_tstw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if (op1.nr == 34  && op2.nr == 3 && op2.reg1 == 0)
   {if (!op32 && op1.reg1 > 2) ende(261,5);
    if (seg32 ^ op32) aus_byte(0x66);
    aus_byte(0xa9);
    if (! op32) aus_word((int)op1.konst); else aus_long(op1.konst);
    goto nextline;
   }

 if (op1.nr == 34  && op2.nr >= 3 && op2.nr <= 30)
   {if (!op32 && op1.reg1 > 2) ende(262,5);
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0xf7);
    mod__sib(0,&op2);
    if (! op32) aus_word((int)op1.konst); else aus_long(op1.konst);
    goto nextline;
   }

 if ( op1.nr == 3 && op2.nr >= 3 && op2.nr <= 30 )
   {adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x85);
    mod_sib(op1.reg1,&op2);
    goto nextline;
   }

 if ( op2.nr == 3 && op1.nr >= 3  && op1.nr <= 30)
   {adr_pre(&op1);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op1);
    aus_byte(0x85);
    mod_sib(op2.reg1,&op1);
    goto nextline;
   }

ende(263,3);

/*************************************************************/
_unlkl:
 op32=1;
/*-----------------------------------------------------------*/
_unlkw:
 get_operand(operand);
 dec_operand(operand,&op1); 

 if (op1.nr == 3  && op1.reg1 == 4)
   {if (seg32 ^ op32) aus_byte(0x66);
    aus_byte(0xc9);
    goto nextline;
   }

 ende(348,3);


/*************************************************************/
_verrw:
 get_operand(operand);
 dec_operand(operand,&op1); 

 if ( op1.nr >= 3 && op1.nr <= 30 )
   {adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0x0f);
    aus_byte(0x00);
    mod__sib(4,&op1);
    goto nextline;
   }

ende(264,3);

/*************************************************************/
_verww:
 get_operand(operand);
 dec_operand(operand,&op1); 

 if ( op1.nr >= 3 && op1.nr <= 30 )
   {adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0x0f);
    aus_byte(0x00);
    mod__sib(5,&op1);
    goto nextline;
   }

ende(265,3);

/*************************************************************/
_wait:
 aus_byte(0x9b);
 goto nextline;

/*************************************************************/
_xaddb:
 get_operand(operand);
 dec_boperand(operand,&op1); 
 get_operand(operand);
 dec_boperand(operand,&op2); 

 if ( op1.nr == 3 && op2.nr >= 3 && op2.nr <= 30 )
   {if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    seg_pre(&op2);
    aus_byte(0x0f);
    aus_byte(0xc0);
    mod_sib(op1.reg1,&op2);
    goto nextline;
   }

 ende(266,3);


/*************************************************************/
_xaddl:
 op32=1;
/*-----------------------------------------------------------*/
_xaddw:
 get_operand(operand);
 dec_operand(operand,&op1); 
 get_operand(operand);
 dec_operand(operand,&op2); 

 if ( op1.nr == 3 && op2.nr >= 3 && op2.nr <= 30 )
   {if (op2.nr > 3 && op_pref==4) {op_pref=0; aus_byte(0xf0);}
    adr_pre(&op2);
    if (seg32 ^ op32) aus_byte(0x66);
    seg_pre(&op2);
    aus_byte(0x0f);
    aus_byte(0xc1);
    mod_sib(op1.reg1,&op2);
    goto nextline;
   }

ende(267,3);


/*************************************************************/




} /* end main */


/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int adr_pre(op) op_typ *op;
{int i;
 i=op->nr;
 if (   seg32 && ( i>=4  && i<=10 || i==43 || i==45 || i==50 )
     ||
       !seg32 && ( i>=11 && i<=30 || i==44 || i==46 || i==51 )
    ) aus_byte(0x67);
}


/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int seg_pre(op) op_typ *op;
{int i;
 i=op->nr;
 if ( (i<4 || i>30) && i!=45 && i!=46 && i!=50 && i!=51 ) return;
 if (op->segm==0 && op->reg1!=4 && op->reg1!=7) return;
 if (op->segm==7 && (op->reg1==4 || op->reg1==7) ) return;

    switch (op->segm)   
      {case 0: aus_byte(0x3e); break;
       case 1: aus_byte(0x26); break;
       case 2: aus_byte(0x64); break;
       case 3: aus_byte(0x65); break;
       case 6: aus_byte(0x2e); break;
       case 7: aus_byte(0x36); break;
       default: ende(268,7);
      }
}



/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int out_byte(i) int i;
{char *p;

 putc(i,com);
 
 if (blk_flag)
    {print_string("\nACHTUNG: Code generiert nach blk-Anweisung in Zeile ");
     print_dec(line_nr);
     print_string("\nblk reserviert keinen Speicherplatz\n");
     blk_flag=0;
    }
}

/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int aus_byte(i) int i;
{if (pass2) 
    {if (line_sp > 36) list_char(EOL);
     list_byte(i);
     list_char(' ');
     out_byte(i);
    }

 (*lab_wert)++;
 lab_wert[1]++;
}

/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int aus_word(i) int i;

{if (pass2) 
    {if (line_sp > 34) list_char(EOL);
     list_byte(i>>8);
     list_byte(i);
     list_char(' ');
     out_byte(i);
     out_byte(i>>8);
    }

 (*lab_wert) += 2;
 lab_wert[1] += 2;
}

/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int aus_long(i) long i;
{if (pass2) 
    {if (line_sp > 30) list_char(EOL);
     list_byte( (int)(i>>24) );
     list_byte( (int)(i>>16) );
     list_byte( (int)(i>>8) );
     list_byte( (int) i );
     list_char(' ');
     out_byte( (int) i );
     out_byte( (int)(i>>8) );
     out_byte( (int)(i>>16) );
     out_byte( (int)(i>>24) );
    }

 (*lab_wert) += 4;
 lab_wert[1] += 4;
}

/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int list_byte(i) int i;
{int j;
 if (!line_sp)
    {
     line_sp=1;

     list_byte( (int)(lab_wert[1] >> 24));
     list_byte( (int)(lab_wert[1] >> 16));
     list_byte( (int)(lab_wert[1] >>  8));
     list_byte( (int)(lab_wert[1]      ));
     list_char(':');
     list_char(' ');

     list_byte( (int)( (*lab_wert) >> 24));
     list_byte( (int)( (*lab_wert) >> 16));
     list_byte( (int)( (*lab_wert) >>  8));
     list_byte( (int)( (*lab_wert)      ));
     list_char(':');
     list_char(' ');
     line_sp -= 1;
    }

 j = (i>>4)&15; 
 if (j<10) list_char(j+'0'); else  list_char(j-10+'a');

 j = i&15; 
 if (j<10) list_char(j+'0'); else  list_char(j-10+'a');
}


/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int list_char(i) int i;
{if (list_level >= 0) {/* putc(i,stdout);*/ putc(i,lst);}
 if (i==EOL) line_sp = 0; else line_sp += 1;
}

/*************************************************************/
/* Rueckgabewert  Intel Register Codierung                   */
/*************************************************************/

int trans(i) int i;
{switch(i & 0x07)
  {case 0: return 0;
   case 1: return 2;
   case 2: return 1;
   case 3: return 3;
   case 4: return 5;
   case 5: return 6;
   case 6: return 7;
   case 7: return 4;
  }
}

/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int mod_sib(reg,op) int reg; op_typ *op;

{mod__sib(trans(reg),op);}


/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int mod__sib(reg,op) int reg; op_typ *op;

{int r1,r2;
 r1 = trans(op->reg1);
 r2 = trans(op->reg2);
 reg = reg << 3; 
 switch(op->nr)

  {case 3 : aus_byte(0xc0 | reg | r1); break;

   case 4 : aus_byte(0x06 | reg);
            if (op->konst > high16 || op->konst < low16) ende(269,5);
            aus_word((int)(op->konst));
            break;

   case 5 : if      (r1 == 6) aus_byte(0x04 | reg);
            else if (r1 == 7) aus_byte(0x05 | reg);
            else if (r1 == 3) aus_byte(0x07 | reg);
            else ende(270,9);
            break; 

   case 6 : if      (r1 == 3 && r2 == 6) aus_byte(reg);
            else if (r1 == 3 && r2 == 7) aus_byte(0x01 | reg);
            else if (r1 == 5 && r2 == 6) aus_byte(0x02 | reg);
            else if (r1 == 5 && r2 == 7) aus_byte(0x03 | reg);
            else ende(271,9);
            break;

   case 7 : if      (r1 == 6) aus_byte(0x44 | reg);
            else if (r1 == 7) aus_byte(0x45 | reg);
            else if (r1 == 5) aus_byte(0x46 | reg);
            else if (r1 == 3) aus_byte(0x47 | reg);
            else ende(272,9);
            if (op->konst > max8 || op->konst < min8) ende(273,4);
            aus_byte((int)(op->konst));
            break; 

   case 8 : if      (r1 ==3 && r2 == 6) aus_byte(0x40 | reg);
            else if (r1 ==3 && r2 == 7) aus_byte(0x41 | reg);
            else if (r1 ==5 && r2 == 6) aus_byte(0x42 | reg);
            else if (r1 ==5 && r2 == 7) aus_byte(0x43 | reg);
            else ende(274,9);
            if (op->konst > max8 || op->konst < min8) ende(275,4);
            aus_byte((int)(op->konst));
            break; 

   case 9 : if      (r1 == 6) aus_byte(0x84 | reg);
            else if (r1 == 7) aus_byte(0x85 | reg);
            else if (r1 == 5) aus_byte(0x86 | reg);
            else if (r1 == 3) aus_byte(0x87 | reg);
            else ende(276,9);
            if (op->konst > max16 || op->konst < min16) ende(277,5);
            aus_word((int)(op->konst));
            break; 

   case 10: if (r1 ==3 && r2 == 6) aus_byte(0x80 | reg);
            else if (r1 ==3 && r2 == 7) aus_byte(0x81 | reg);
            else if (r1 ==5 && r2 == 6) aus_byte(0x82 | reg);
            else if (r1 ==5 && r2 == 7) aus_byte(0x83 | reg);
            else ende(278,9);
            if (op->konst > max16 || op->konst < min16) ende(279,5);
            aus_word((int)(op->konst));
            break; 

   case 11: aus_byte(0x05 | reg);
            aus_long(op->konst);
            break;

   case 12: if (r1==4) {aus_byte(0x04 | reg); aus_byte(0x24); break;}
            aus_byte(r1 | reg); break;

   case 13: if (r1==4) {aus_byte(0x44 | reg); aus_byte(0x24);}
               else aus_byte(0x40 | r1 | reg);
            if (op->konst > max8 || op->konst < min8) ende(280,5);
            aus_byte((int)(op->konst));
            break; 

   case 14: if (r1==4) {aus_byte(0x84 | reg); aus_byte(0x24);}
               else aus_byte(0x80 | r1 | reg);
            aus_long(op->konst);
            break; 

   case 15: aus_byte(0x04 | reg);
            aus_byte((r2<<3) | r1);
            break; 

   case 16: aus_byte(0x04 | reg);
            aus_byte(0x40 | (r2<<3) | r1);
            break; 

   case 17: aus_byte(0x04 | reg);
            aus_byte(0x80 | (r2<<3) | r1);
            break; 

   case 18: aus_byte(0x04 | reg);
            aus_byte(0xc0 | (r2<<3) | r1);
            break; 

   case 19: aus_byte(0x04 | reg);
            aus_byte(0x05 | (r2<<3) );
            aus_long(op->konst);
            break; 

   case 20: aus_byte(0x04 | reg);
            aus_byte(0x45 | (r2<<3) );
            aus_long(op->konst);
            break; 

   case 21: aus_byte(0x04 | reg);
            aus_byte(0x85 | (r2<<3) );
            aus_long(op->konst);
            break; 

   case 22: aus_byte(0x04 | reg);
            aus_byte(0xc5 | (r2<<3) );
            aus_long(op->konst);
            break; 

   case 23: aus_byte(0x44 | reg);
            aus_byte((r2<<3) | r1);
            if (op->konst > max8 || op->konst < min8) ende(281,4);
            aus_byte((int)(op->konst));
            break; 

   case 24: aus_byte(0x44 | reg);
            aus_byte(0x40 | (r2<<3) | r1);
            if (op->konst > max8 || op->konst < min8) ende(282,5);
            aus_byte((int)(op->konst));
            break; 

   case 25: aus_byte(0x44 | reg);
            aus_byte(0x80 | (r2<<3) | r1);
            if (op->konst > max8 || op->konst < min8) ende(283,5);
            aus_byte((int)(op->konst));
            break; 

   case 26: aus_byte(0x44 | reg);
            aus_byte(0xc0 | (r2<<3) | r1);
            if (op->konst > max8 || op->konst < min8) ende(284,5);
            aus_byte((int)(op->konst));
            break; 

   case 27: aus_byte(0x84 | reg);
            aus_byte((r2<<3) | r1);
            aus_long(op->konst);
            break; 

   case 28: aus_byte(0x84 | reg);
            aus_byte(0x40 | (r2<<3) | r1);
            aus_long(op->konst);
            break; 

   case 29: aus_byte(0x84 | reg);
            aus_byte(0x80 | (r2<<3) | r1);
            aus_long(op->konst);
            break; 

   case 30: aus_byte(0x84 | reg);
            aus_byte(0xc0 | (r2<<3) | r1);
            aus_long(op->konst);
            break; 

   default: ende(285,8);
  }
}


/*************************************************************/
/* return 1:byte  2:word  3:long Operand                     */
/*************************************************************/

int get_wert(p,li) char *p; long *li;
{int i;
 if (i=get_w(p,li)) return (i);
 if (!pass2) {*li=0; return (1);}
 ende(286,10);
}

/*************************************************************/
/* return 0:Berechnung nicht meglich                         */
/*        1:byte  2:word  3:long Operand                     */
/*************************************************************/
#define max_tiefe 20

/*

hoechste Prioritaet
 ()             : Klammern
 !   ~   -      : logisches not, binaeres not, Minus-Vorzeichen
 *   /   \      : Multiplikation, Division, Rest (2er-Komplement-Darst.)
 +   -          : Addition, Subtraktion
 <<  >>         : Linksshift, Rechtsshift
 <   >   <=  >= : kleiner, groesser, kleiner-gleich, groesser-gleich
 ==  !=         : gleich, nicht gleich
 &              : binaeres AND
 ^              : binaeres XOR
 |              : binaeres OR
 &&             : logisches UND    (FALSE = 0;  TRUE=alles andere
 ||             : logisches ODER    TRUE als Ergebnis = 1)
niedrigste Prioritaet

Bei gleicher Prioritaet von links nach rechts ausser bei (! ~ -),
hier von rechts nach links.

!   : 0x00   (%000000 00)
~   : 0x01   (%000000 01)
-   : 0x02   (%000000 10)
*   : 0x04   (%000001 00)
/   : 0x05   (%000001 01)
\   : 0x06   (%000001 10)
+   : 0x08   (%000010 00)
-   : 0x09   (%000010 01)
<<  : 0x0c   (%000011 00)  
>>  : 0x0d   (%000011 01)
<   : 0x10   (%000100 00)
>   : 0x11   (%000100 01)
<=  : 0x12   (%000100 10)
>=  : 0x13   (%000100 11)
==  : 0x14   (%000101 00)
!=  : 0x15   (%000101 01)
&   : 0x18   (%000110 00)
^   : 0x1c   (%000111 00)
|   : 0x20   (%001000 00)
&&  : 0x24   (%001001 00)
||  : 0x28   (%001010 00)
NULL: 0x2c   (%001011 00)
(   : 0x30   (%001100 00)
)   : 0x31   (%001100 01)


*/

int get_w(p,li) char *p; long *li;
{int i=0,j=0,k;
 long la[max_tiefe+5];
 char ca[max_tiefe+5];

 ca[0]=0x34;

 while (1)
  {while (1)
    {if (i > max_tiefe || j > max_tiefe) ende(287,26);
     if (!*p) ende(288,11);
     if (*p == '(') {ca[++i]= 0x30; p++; continue;}
     if (*p == '!') {ca[++i]= 0x00; p++; continue;}
     if (*p == '~') {ca[++i]= 0x01; p++; continue;}
     if (*p == '-') {ca[++i]= 0x02; p++; continue;}

     if (*p == '$' || *p == '%' || *p == '"' || *p == '\'' || buchzahl(*p))
        {if (!get_zahl(&p,&la[++j])) return 0; break; }
     ende(289,12);
    }

   while (1) 
    {switch (*(p++))
        {case '*' : {k=0x04; break;}
         case '/' : {k=0x05; break;}
         case '\\': {k=0x06; break;}
         case '+' : {k=0x08; break;}
         case '-' : {k=0x09; break;}
         case '<' : {if (*p == '<') {k=0x0c; p++; break;}
                     if (*p == '=') {k=0x12; p++; break;}
                     k=0x10; break;}
         case '>' : {if (*p == '>') {k=0x0d; p++; break;}
                     if (*p == '=') {k=0x13; p++; break;}
                     k=0x11; break;}
         case '=' : {if (*p == '=') {k=0x14; p++; break;}
                     ende(290,14);}
         case '!' : {if (*p == '=') {k=0x15; p++; break;}
                     ende(291,14);}
         case '&' : {if (*p == '&') {k=0x24; p++; break;}
                     k=0x18; break;}
         case '^' : {k=0x1c; break;}
         case '|' : {if (*p == '|') {k=0x28; p++; break;}
                     k=0x20; break;}
         case ')' : {k=0x31; break;}
         case  0  : {k=0x2c; break;}
         default  : ende(292,14);
        }

     while ( (k|0x03) >= ca[i] )
        {if (j<1) ende(293,14); /*eigentlich unmoeglich*/
         switch(ca[i--])
            { case 0x00: {     la[j] = !la[j]          ; break;}
              case 0x01: {     la[j] = ~la[j]          ; break;}
              case 0x02: {     la[j] = -la[j]          ; break;}
              case 0x04: {j--; la[j] = la[j] *  la[j+1]; break;}
              case 0x05: {j--; la[j] = la[j] /  la[j+1]; break;}
              case 0x06: {j--; la[j] = la[j] %  la[j+1]; break;}
              case 0x08: {j--; la[j] = la[j] +  la[j+1]; break;}
              case 0x09: {j--; la[j] = la[j] -  la[j+1]; break;}
              case 0x0c: {j--; la[j] = la[j] << la[j+1]; break;}
              case 0x0d: {j--; la[j] = la[j] >> la[j+1]; break;}
              case 0x10: {j--; la[j] = la[j] <  la[j+1]; break;}
              case 0x11: {j--; la[j] = la[j] >  la[j+1]; break;}
              case 0x12: {j--; la[j] = la[j] <= la[j+1]; break;}
              case 0x13: {j--; la[j] = la[j] >= la[j+1]; break;}
              case 0x14: {j--; la[j] = la[j] == la[j+1]; break;}
              case 0x15: {j--; la[j] = la[j] != la[j+1]; break;}
              case 0x18: {j--; la[j] = la[j] &  la[j+1]; break;}
              case 0x1c: {j--; la[j] = la[j] ^  la[j+1]; break;}
              case 0x20: {j--; la[j] = la[j] |  la[j+1]; break;}
              case 0x24: {j--; la[j] = la[j] && la[j+1]; break;}
              case 0x28: {j--; la[j] = la[j] || la[j+1]; break;}
              case 0x30: goto weiter;
              default: ende(294,14);
            }
        }
     if (k==0x2c) goto fertig;
     ca[++i] = k;
     break;
weiter:;
    }
  }

fertig:
 if (i || --j) ende(295,14);
 *li=la[1];
 if ( !(*li & ~high8)  || !(~*li & min8) ) return 1;
 if ( !(*li & ~high16) || !(~*li & min16)) return 2;
 return 3;
}


/*************************************************************/
/* Rueckgabewert  0: Zahl konnte nicht berechnet werden      */
/*                1: Zahl konnte berechnet werden            */
/*************************************************************/

int get_zahl(pp,lip)  char **pp; long *lip;
{char *q;
 int i,j;

 q = *pp;
 *lip = 0;

 if (*q>='0' && *q<='9') 
    {while (*q >= '0' && *q <= '9') *lip = 10 * (*lip) + *q++ -'0';
     *pp = q;
     return 1;}

 if (*q=='%') 
    {q++;
     while (*q == '0' || *q == '1') *lip = 2 * (*lip) + *q++ -'0';
     *pp = q;
     return 1;}

 if (*q=='$')
    {q++;
     while ( (i='0', *q >= '0' && *q <= '9') || 
             (i='a'-10, *q >= 'a' && *q <= 'f')    )
     *lip = 16 * (*lip) + *q++ -i;
     *pp = q;
     return 1;}

 if ( (i = *q) == '\'' || i == '"')
    {q++;
     for (j=1; j<=4; j++)
         {if (! *q ) {*pp = q; return 1;}
          if (*q == i) {*pp = q+1; return 1;}
          *lip = (*lip << 8) + *q++;
         }
     if (*q == i) {*pp = q+1; return 1;}
     ende(296,22);
    }

 if (buchst(*q))
    { while (buchzahl(*++q));
      i = *q;
      *q = 0;
      if (get_lab(*pp,lip)) {*q = i; *pp = q; return 1;}
      *q = i;
    }
 return 0;
}


/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int get_operand(p) char *p;
{int ch,i=0,j=0;

 while ((ch=read_char()) == ' ');
 if (ch==EOL) {p[0]=0; return;}
 while ( (p[i++]=ch) != EOL ) ch=read_char();
 p[--i]=0;
 del_blank(p);
}


/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int del_blank(p) char *p;
{char *q,*p1;
 int ch=0, l_ch, l_bz;
 int instring=0;

 q=p;
 while (l_ch=ch, ch = *q++ = *p++)
   {if (l_ch!=' ') l_bz=buchzahl(l_ch);
    if (ch==instring) {instring=0; continue;}
    if (instring)  continue;
    if (ch=='\'' || ch=='"') {instring=ch; continue;}
    if (ch==' ') q--;
    if ( !(l_ch==' ' && buchzahl(ch) && l_bz) ) continue;
    p1=p; while(*++p1 == ' ');
    if (ch!='.' || *p!='b' && *p!='w'  && *p!='l' 
                || *p1!=0  && *p1!='(' && *p1!='{'     ) ende(297,17);
   }
 *q++ = 0;
}
      

/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int dec_boperand(p,op) char *p; op_typ *op;

{dec_operand(p,op);
 if (op->nr==3 && op->reg1>3) ende(298,15);
 if (op->nr==2) op->nr=3;
 return;
}


/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int dec_operand(p,op) char *p; op_typ *op;

{int i;
 int par[5];

 if (!*p) {op->nr=1; return;}

 if (p[0]=='m' && p[1]>='0' && p[1]<='7' && !p[2])
    {op->nr=2;
     switch (p[1])
       {case '0': op->reg1=7; break;
        case '1': op->reg1=5; break;
        case '2': op->reg1=4; break;
        case '3': op->reg1=6; break;
        default : ende(299,9);
       }
     return;
    }

 if (p[0]=='r' && p[1]>='0' && p[1]<='7' && !p[2])
    {op->nr=3;
     op->reg1= p[1]-'0';
     return;
    }

 if ( finds ( p , ".w{s?}" , par) )
    {op->nr=4;
     op->reg1=0;
     op->segm=par[0];
     i=get_wert(p,&op->konst);
     if (i>2) ende(300,5);
     return;
    }

 if ( finds ( p , ".b(r?.w){s?}" , par) )
    {op->nr=7;
     if (par[1]<3 || par[1]>6) ende(301,9);
     op->reg1=par[1];
     op->segm=par[0];
     i=get_wert(p,&op->konst);
     if ( i !=1 ) ende(302,4);
     return;
    }

 if ( finds ( p , ".w(r?.w){s?}" , par) )
    {nr9:
     op->nr=9;
     if (par[1]<3 || par[1]>6) ende(303,9);
     op->reg1=par[1];
     op->segm=par[0];
     i=get_wert(p,&op->konst);
     if (i>2) ende(304,5);
     return;
    }

 if ( finds ( p , "(r?.w){s?}" , par) )
    {if ( *p ) goto nr9;
     op->nr=5;
     if (par[1]!=3 && par[1]!=5 && par[1]!=6) ende(305,9);
     op->reg1=par[1];
     op->segm=par[0];
     return;
    }

 if ( finds ( p , ".b(r?.w,r?.w){s?}" , par) )
    {op->nr=8;
     if (par[2]!=3 && par[2]!=4) ende(306,9);
     op->reg1=par[2];
     if (par[1]!=5 && par[1]!=6) ende(307,9);
     op->reg2=par[1];
     op->segm=par[0];
     i=get_wert(p,&op->konst);
     if ( i != 1) ende(308,4);
     return;
    }

 if ( finds ( p , ".w(r?.w,r?.w){s?}" , par) )
    {nr10:
     op->nr=10;
     if (par[2]!=3 && par[2]!=4) ende(309,9);
     op->reg1=par[2];
     if (par[1]!=5 && par[1]!=6) ende(310,9);
     op->reg2=par[1];
     op->segm=par[0];
     i=get_wert(p,&op->konst);
     if (i>2) ende(311,5);
     return;
    }

 if ( finds ( p , "(r?.w,r?.w){s?}" , par) )
    {if (*p) goto nr10;
     op->nr=6;
     if (par[2]!=3 && par[2]!=4) ende(312,9);
     op->reg1=par[2];
     if (par[1]!=5 && par[1]!=6) ende(313,9);
     op->reg2=par[1];
     op->segm=par[0];
     return;
    }

 if ( finds ( p , ".b(r?.l){s?}" , par))
    {op->nr=13;
     op->reg1=par[1];
     op->segm=par[0];
     i=get_wert(p,&op->konst);
     if ( i !=1) ende(314,4);
     return;
    }

 if ( finds ( p , ".l(r?.l){s?}" , par)) 
    {op->reg1=par[1];
     op->segm=par[0];
     if (*p)
        {
         op->nr=14;
         get_wert(p,&op->konst);
         /* folgende Zeile kann weggelassen werden; verwendet SIB-Byte
            anstatt Segmentprefix (wollte wissen ob's geht) */
         if (op->segm==0 && op->reg1==4) {op->nr=19; op->reg1=0; op->reg2=4;}
         return;
        }
        else 
        {op->nr=12;
        if (par[1]==4) {op->nr=13; op->konst=0;}
        return;
       }
    }

 if ( finds ( p , ".l(r?.l*2){s?}" , par) )
    {op->nr=20;
     op->reg1=0;
     if (par[1]>6) ende(315,9);
     op->reg2=par[1];
     op->segm=par[0];
     get_wert(p,&op->konst);
     return;
    }

 if ( finds ( p , ".l(r?.l*4){s?}" , par) )
    {op->nr=21;
     op->reg1=0;
     if (par[1]>6) ende(316,9);
     op->reg2=par[1];
     op->segm=par[0];
     get_wert(p,&op->konst);
     return;
    }

 if ( finds ( p , ".l(r?.l*8){s?}" , par) )
    {op->nr=22;
     op->reg1=0;
     if (par[1]>6) ende(317,9);
     op->reg2=par[1];
     op->segm=par[0];
     get_wert(p,&op->konst);
     return;
    }

 if ( finds ( p , ".b(r?.l,r?.l){s?}" , par) )
    {op->nr=23;

     if (par[1]==7) {par[1]=par[2]; par[2]=7;}
     if (par[2]==4 && par[0]==0) {par[2]=par[1]; par[1]=4;}
     if (par[2]!=7 && par[0]==7 && par[1]==4)  {par[1]=par[2]; par[2]=4;}

     if (par[1]>6) ende(319,9);
     op->reg1=par[2];
     op->reg2=par[1];
     op->segm=par[0];
     i=get_wert(p,&op->konst);
     if ( i!=1 ) ende(320,4);
     return;
    }

 if ( finds ( p , ".b(r?.l,r?.l*2){s?}" , par) )
    {op->nr=24;
     if (par[1]>6) ende(321,9);
     op->reg1=par[2];
     op->reg2=par[1];
     op->segm=par[0];
     i=get_wert(p,&op->konst);
     if ( i!=1 ) ende(322,4);
     return;
    }

 if ( finds ( p , ".b(r?.l,r?.l*4){s?}" , par) )
    {op->nr=25;
     if (par[1]>6) ende(323,9);
     op->reg1=par[2];
     op->reg2=par[1];
     op->segm=par[0];
     i=get_wert(p,&op->konst);
     if ( i!=1 ) ende(324,4);
     return;
    }

 if ( finds ( p , ".b(r?.l,r?.l*8){s?}" , par) )
    {op->nr=26;
     if (par[1]>6) ende(325,9);
     op->reg1=par[2];
     op->reg2=par[1];
     op->segm=par[0];
     i=get_wert(p,&op->konst);
     if ( i!=1 ) ende(326,4);
     return;
    }

 if ( finds ( p , ".l(r?.l,r?.l){s?}" , par) )
    {if (par[1]==7) {par[1]=par[2]; par[2]=7;}
     if (par[2]==4 && par[0]!=7) {par[2]=par[1]; par[1]=4;}
     if (par[2]!=7 && par[0]==7 && par[1]==4)  {par[1]=par[2]; par[2]=4;}

     if (par[1]>6) ende(327,9);
     op->reg1=par[2];
     op->reg2=par[1];
     op->segm=par[0];
     if (*p)
        {
         op->nr=27;
         get_wert(p,&op->konst);
         return;
        }
        else
        {
         op->nr=15;
         if (op->reg1==4){op->nr=23; op->konst=0;}
         return;
        }
    }

 if ( finds ( p , ".l(r?.l,r?.l*2){s?}" , par) )
    {if (par[1]>6) ende(328,9);
     op->reg1=par[2];
     op->reg2=par[1];
     op->segm=par[0];
     if (*p)
        {op->nr=28;
         get_wert(p,&op->konst);
         return;
        }
        else
        {
         op->nr=16;
         if (op->reg1==4){op->nr=24; op->konst=0;}
         return;
        }
    }

 if ( finds ( p , ".l(r?.l,r?.l*4){s?}" , par) )
    {if (par[1]>6) ende(329,9);
     op->reg1=par[2];
     op->reg2=par[1];
     op->segm=par[0];
     if (*p) 
        {
         op->nr=29;
         get_wert(p,&op->konst);
         return;
        }
        else
        {
         op->nr=17;
         if (op->reg1==4){op->nr=25; op->konst=0;}
         return;
        }
    }

 if ( finds ( p , ".l(r?.l,r?.l*8){s?}" , par) )
    {if (par[1]>6) ende(330,9);
     op->reg1=par[2];
     op->reg2=par[1];
     op->segm=par[0];
     if (*p) 
        {
         op->nr=30;
         get_wert(p,&op->konst);
         return;
        }
        else
        {
         op->nr=18;
         if (op->reg1==4){op->nr=26; op->konst=0;}
         return;
        }
    }

 if ( finds ( p , "(r7.x)+{s7}" , par) || finds ( p , "(sp)+" , par) )
    {op->nr=31;
     if (*p) ende(331,9);
     return;
    }

 if ( finds ( p , "-(r7.x){s7}" , par) || finds ( p , "-(sp)" , par)  )
    {op->nr=32;
     if (*p) ende(332,9);
     return;
    }

 if ( cmps ( p , "r0-r7" , par) )
    {op->nr=33;
     return;
    }

 if (p[0]=='#')
    {p++;
     op->nr=34;
     op->reg1 = get_wert(p,&op->konst);
     return;
    }

 if (p[0]=='s' && p[1]=='r' && !p[2])
    {op->nr=35;
     return;
    }

 if (p[0]=='c' && p[1]=='r' && p[2]>='0' && p[2]<='3' && !p[3])
    {op->nr=36;
     op->reg1= p[2]-'0';
     return;
    }

 if (p[0]=='d' && p[1]=='r' && p[2]>='0' && p[2]<='7' && !p[3])
    {op->nr=37;
     op->reg1= p[2]-'0';
     return;
    }

 if (p[0]=='t' && p[1]=='r' && p[2]>='3' && p[2]<='7' && !p[3])
    {op->nr=38;
     op->reg1= p[2]-'0';
     return;
    }

 if (cmps(p,"ldtr"))
    {op->nr=39;
     return;
    }

 if (cmps(p,"gdtr"))
    {op->nr=40;
     return;
    }

 if (cmps(p,"idtr"))
    {op->nr=41;
     return;
    }

 if (cmps(p,"tr"))
    {op->nr=42;
     return;
    }

 if (cmps(p,"(r6.w)+-{s1}"))
    {op->nr=43;
     return;
    }

 if (cmps(p,"(r6.l)+-{s1}") || cmps(p,"(r6)+-{s1}") )
    {op->nr=44;
     return;
    }

 if ( finds ( p , "(r5.w)+-{s?}" , par) )
    {op->nr=45;
     op->reg1=0;
     op->segm=par[0];
     if (*p) ende(333,9);
     return;
    }

 if ( finds ( p , "(r5.l)+-{s?}" , par) )
    {op->nr=46;
     op->reg1=0;
     op->segm=par[0];
     if (*p) ende(334,9);
     return;
    }

 if (cmps(p,"r1|r0"))
    {op->nr=47;
     return;
    }

 if (cmps(p,"m0|r0"))
    {op->nr=48;
     return;
    }

 if ( finds ( p , "s?|r?" , par) )
    {op->nr=49;
     op->reg1=par[0];
     op->segm=par[1];
     if (*p) ende(335,9);
     return;
    }

 if ( finds ( p , "(r3.w,r0.b){s?}" , par) )
    {op->nr=50;
     op->reg1=0;
     op->segm=par[0];
     if (*p) ende(336,9);
     return;
    }

 if ( finds ( p , "(r3.l,r0.b){s?}" , par) )
    {op->nr=51;
     op->reg1=0;
     op->segm=par[0];
     if (*p) ende(337,9);
     return;
    }

 if (p[0]=='s' && p[1]>='0' && p[1]<='7' && !p[2])
    {op->nr=52;
     op->segm= p[1]-'0';
     switch(p[1]-'0')
       {case 0: {op->reg1=3; return;}
        case 1: {op->reg1=0; return;}
        case 2: {op->reg1=7; return;}
        case 3: {op->reg1=4; return;}
        case 6: {op->reg1=2; return;}
        case 7: {op->reg1=1; return;}
        default: ende(338,16);
       }
    }


 if ( i = finds ( p , ".l{s?}" , par) )
    {op->nr=11;
     op->reg1=0;
     op->segm=par[0];
     get_wert(p,&op->konst);
     if (i==2 && !seg32 && !(op->konst & (~high16) )) op->nr=4;
     return;
    }

 ende(939,16);
}


/*************************************************************/
/* Rueckgabewert  0:nicht gefunden  1+n: gefunden            */
/*                n: Anzahl nicht vorhandener .l             */
/*************************************************************/

int finds(p,q,pi) char *p,*q; int *pi;
{int i=0,j=1;

 while (*p) p++; --p;
 while (*q) { i++; q++;} --q;

 if (*q == '}' && *(q-1) == '?' && *p != '}') 
    { i=i-4; q=q-4; *pi++ = 0; }

 while (i--)
  {
   if ( *q != '?')
      if (*p-- == *q--) continue;
         else if (i>0 && *(q+1) == 'l' && *q-- == '.') 
                           {i--; j++; p++; continue;}
         else if ( *(q+1) == '.' && *(q+2) == 'l') 
                           { j++; p=p+2; continue;}
                 else return 0;
   if ( *p < '0' || *p > '7') return 0;
   *pi++ = *p-- - '0';
   q--;
  }
 *++p = 0;
 return j;
}
 

/*************************************************************/
/* Rueckgabewert  0:nicht gleich  1: gleich                  */
/*************************************************************/

int cmps(p,q) char *p,*q;
{while (*p && *p==*q) p++,q++;
 return *p?0:!*q;
}


/*************************************************************/
/* Rueckgabewert  0: kein Opcode  1:Opcode gefunden          */
/*************************************************************/

int get_opcode(p) char *p;
{int ch,i;
 char *q;

 op_pref=0;

 while (1)
  {q=p; q[0]=0;
   while ( (ch=read_char()) == ' ');
   if (last_ch==EOF) return 0;
   if (ch==EOL) return 1;
   if (!buchst(ch)) ende(340,12);
   while (*q++=ch, buchzahl(ch=read_char()));

   if (ch == ' ') 
      {while (next_ch == ' ') ch = read_char();
       if (next_ch == ':' || next_ch == '=') ch = read_char();
      }

   if (ch=='=') 
      {while (next_ch == ' ') read_char();
       *q++ = *p; *q = 0;
       if (next_ch == '=') {read_char();  *p = ':'; return 1;}
          else                          { *p = '='; return 1;}
      }

   *q=0;
   if (ch==EOL) return 1;
   if (ch==' ') 
      {if (op_pref) return 1;
       if (cmps(p,"rep_r2")) {op_pref=1; continue;}
       if (cmps(p,"repeq_r2")) {op_pref=2; continue;}
       if (cmps(p,"repne_r2")) {op_pref=3; continue;}
       if (cmps(p,"lock")) {op_pref=4; continue;}
       if (cmps(p,"word")) {op_pref=5; continue;}
       if (cmps(p,"long")) {op_pref=6; continue;}
       return 1;
      }

   if (ch!=':') ende(341,12);

   while (next_ch == ' ') read_char();
   if (next_ch == ':')  {read_char(); i=3;} else i=2;
   if (if_wert<0) continue;
   if (p[0]=='_') i=1;  
   ins_lab(p,*lab_wert,i);
  }
}

/*************************************************************/
/* Rueckgabewert  Nummer des Labels  -1 falls nicht vorhanden*/
/*************************************************************/

int find_lab(p) char *p;
{int i,j;

 if (*p == '_')
    {i=lab_lokal-1;
     do         /*10.2.94*/
      {i++; 
       while ( (j=abs(lab_guelt[i])) ==1) if (cmps(lab_pa[i++],p)) return i-1;
      } 
     while ( j==4 || (j && (*lab_pa[i]=='.')) );
     return -1;
    }

 i=lab_block;
 while (lab_guelt[i]!=0) 
       {if (abs(lab_guelt[i])==2 && cmps(lab_pa[i],p)) return i;
        i++;
       }

 i=0;
 while (i<=lab_last)
       {if (   (abs(lab_guelt[i])==3 || lab_guelt[i]==4)
            && cmps(lab_pa[i],p)) return i;
        i++;
       }

 return -1;

}

/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int ins_lab(p,wert,g) char *p; long wert; int g;
{char *q;
 int i=0;

 q=p;
 while (*q++) if (*q == '.') ende(342,18); /*10.2.94*/

 if (*p == '@') if (g<0 ) ende(144,10); else g=4; 

 if ( (i=find_lab(p)) >= 0)
    {if (!pass2 && g != 4 ) ende(343,19); 
     lab_wert[i]=wert; lab_guelt[i]=g;
     if (*p != '_' && *p != '.' && *p !='@') lab_lokal=i+1; /*10.2.94*/
    }
 else
    {q=lab_pa[(i = ++lab_last)];
     if (*p != '_' && *p != '.' && *p !='@') lab_lokal=i+1; /*10.2.94*/
     if ( q > (lab_buf + maxbuf) ) ende(344,23);
     while (*q++ = *p++);
     if (lab_last > maxlabel) ende(345,24);
     lab_wert[i]=wert;
     lab_guelt[i]=g;
     lab_pa[i+1]=q;
     lab_guelt[i+1]=0;
    }
}


/*************************************************************/
/* return 0:ungueltiger  1:gueltiger  Labelwert              */
/*************************************************************/

int get_lab(p,wert) char *p; long *wert;
{int i=0;

 if ( (i=find_lab(p)) >= 0) 
    {*wert=lab_wert[i];
     if (lab_guelt[i]>0) return 1;
    }
 return 0;

}


/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int list_label()
{int i,j;
 long li;
 char *p;

 list_char(EOL);
 line_sp=110;

 for (i=0; i <= lab_last; i++) 
   {p = lab_pa[i];
    if ( lab_guelt[i] > 1 && *p != '@')
       {if (line_sp > 64) list_char(EOL);
           else for (j=0; j<3; j++) list_char(' ');
        j=0;
        while (*p) {list_char(*p++); j++;}
        while (j < 15) {list_char('.'); j++;}
        list_char(' ');
        li = lab_wert[i];
        list_byte( (int)(li>>24) );
        list_byte( (int)(li>>16) );
        list_byte( (int)(li>>8) );
        list_byte( (int) li );
       }
   }
}
 

/*************************************************************/
/* Rueckgabewert  0:kein Buchstabe  1:Buchstabe              */
/*************************************************************/

int buchst(ch) char ch;
{if (ch=='.' || ch=='_' || ch=='@') return 1;
 if (ch >= 'a' && ch <= 'z' )  return 1;
 return 0;
}


/*************************************************************/
/* Rueckgabewert  0:kein Buchstabe/Zahl  1:Buchstabe/Zahl    */
/*************************************************************/

int buchzahl(ch) char ch;
{
 return (buchst(ch) || ( ch>='0' && ch<='9' ) );
}


/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int skip_line()
{while (last_ch != EOL && last_ch != EOF) read_char();
}


/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/

int read_eol()
{int i;
 if (last_ch != EOL && last_ch != EOF) 
    {while (read_char() == ' ');
     if (last_ch != EOL && last_ch != EOF) ende(346,20);
    }
 if (last_ch == EOL) last_ch=0;

 if (pass2) 
    {while (line_sp < 40) list_char(' ');
     for (i=0;i<l_line_lang;i++) list_char(last_line[i]);
     l_line_lang=0;
    }

 line_nr++;
 return;
}


/*************************************************************/
/* Rueckgabewert gelesenes Zeichen                           */
/*************************************************************/

int read_char()
{int ch;
 static int instring = 0;

 if ( (ch=get_char()) == ';' && !instring) 
    { while ( (ch=get_char()) != EOL );
      return (ch);
    }

 if (ch == instring) {instring=0; return (ch);}
 if (instring==')') goto abc;
 if (instring) return(ch);
 if (ch == '\'' || ch == '"') {instring=ch; return(ch);}
 if (ch == '(' ) {instring=')'; return (ch);} /* kein Ende bei , */
 if (ch ==',') return (EOL);
abc:
 if (ch >= 'A' && ch <= 'Z') ch+='a'-'A';

 return (ch);

}


/*************************************************************/
/* Rueckgabewert gelesenes Zeichen                           */
/*************************************************************/

int get_char()
{if (last_ch==EOL || last_ch==EOF) return EOL;
 last_ch = next_ch;
 next_ch = getc(mac);
 if ( last_ch  == EOF ) return (EOL);
 if (last_ch==TAB) last_ch=' ';
 if (last_ch==CR) if (next_ch==EOL) last_ch=' '; else last_ch=EOL;
 
if (pass2) 
    { if (l_line_lang >= max_line_lang) ende(347,21);
      last_line[l_line_lang++]=last_ch; 
    }
/*    else putc(last_ch,stdout);
*/

 return (last_ch);
}


/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/
int ende(j,i) int j,i;

{char *p;
 static char *(meld[]) = {

/*  0 */ "Normales Ende" ,
/*  1 */ "Unbekannter Opcode" ,
/*  2 */ "Unerlaubter Prefix" ,
/*  3 */ "Ungueltiger Operand fuer diesen Befehl" ,
/*  4 */ "Byte-Wert zu gross" ,
/*  5 */ "Word-Wert zu gross" ,
/*  6 */ "Zu grosser Sprungoffset" ,
/*  7 */ "Ungueltiges Segment" ,
/*  8 */ "mod-sib-Byte Fehler" ,
/*  9 */ "Ungueltige Adressierung" ,
/* 10 */ "Label nicht gefunden" ,
/* 11 */ "Kein Wert" ,
/* 12 */ "Ungueltiges Zeichen" ,
/* 13 */ "Ungueltige Klammer" ,
/* 14 */ "Ungueltiger Ausdruck" ,
/* 15 */ "Ungueltiges Byte-Register" ,
/* 16 */ "Ungueltiger Operand" ,
/* 17 */ "Ungueltiges Leerzeichen" ,
/* 18 */ "Punkt im Label" ,
/* 19 */ "Label doppelt definiert" ,
/* 20 */ "Zu viele Operanden" ,
/* 21 */ "Zu lange Eingabezeile" ,
/* 22 */ "Zu lange ASCII-Konstante" ,
/* 23 */ "Labelpuffer voll" ,
/* 24 */ "Pointer-Array fuer Label voll" ,
/* 25 */ "Ungueltige ASCII-Konstante" ,
/* 26 */ "Zu viele Klammern" ,
/* 27 */ "Felendes ENDIF" ,
/* 28 */ "Zu viele IF's" ,
/* 29 */ "Zu viele ELSE's" , 
/* 30 */ "Zu viele ENDIF's", 
/* 31 */ "Quelltextdatei konnte nicht geoeffnet werden", 
/* 32 */ "Listdatei konnte nicht geoeffnet werden" ,
/* 33 */ "COM-Datei konnte nicht geoeffnet werden" 

};
 print_string("\n\n");
 print_dec(j);
 print_string(" : ");
 print_string(meld[i]);
 print_string(" in Zeile "); 
 print_dec(line_nr);
 print_string("\n"); 
 
 if (mac!=NULL) fclose(mac);
 if (pass2) {if (lst!=NULL) fclose(lst); 
             if (com!=NULL) fclose(com);}
#if rechner==atari
 print_string("\nWeiter mit beliebiger Taste (ausser RETURN)");
 getc(stdin);
#endif
 exit(0);
}


/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/
int print_dec(i) int i;
{int k,j=1;
 if (i<0) {putc('-',stdout); i = -i;}
 k=i;
 while (k /= 10) j *= 10;
 while (j)
     {k=i/j;
      putc(k+'0',stdout);
      i -= k*j;
      j /= 10;
     }
}


/*************************************************************/
/* kein Rueckgabewert                                        */
/*************************************************************/
int print_string(p) char *p;

{while (*p) putc(*p++,stdout);
}


